#ifndef __GBADECOMPRESS_H__
#define __GBADECOMPRESS_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include "agb.h"

/**
 * Decompresses memory compressed with GBACompress
 * \param src the source memory pointer
 * \param src_len the size of the source memory buffer
 * \param dst the destination memory buffer
 * \param dst_len the pointer that will the length of the decompressed data
 * \param wrkmem Set this to be NULL
 * \return An error code or 0 for no error
 */
extern int GBADecompress( const u8 * src, u32  src_len,u8 * dst, u32 * dst_len,void * wrkmem );

// Same as above but slower as it does safe decompresses to VRAM to avoid corruption
extern int GBADecompressVRAM( const u8 * src, u32  src_len,u8 * dst, u32 * dst_len,void * wrkmem );

#define DmaCompressedCopy(dma,source,dest,bits)	\
{	\
	u32 _temp;	\
	GBADecompress((u8*)(source),0,(u8*) EX_WRAM,&_temp,(void *)0);	\
	DmaCopy(3,EX_WRAM,dest,_temp,32);	\
	DmaWait(3);	\
}

#ifdef __cplusplus
};
#endif

#endif
