#include <stdio.h>
#include <stdlib.h>
#include "DataBase.h"

DataBase::DataBase()
{
	Clear();
}

DataBase::~DataBase()
{
}

void DataBase::Save(void)
{
	FILE *fp;

	fp = fopen("c:\\samples.db","wb");

	if (!fp)
	{
		return;
	}

	int value = -1;

	Iterate(true);
	ItemData *item;

	while ( (item = Iterate()) != 0)
	{
		int namelen = item->mName.size();
		fwrite(&namelen,sizeof(namelen),1,fp);
		fwrite(&item->mName[0],1,item->mName.size(),fp);
		fwrite(&item->mSize,sizeof(item->mSize),1,fp);
		if (item->mSize > 0)
		{
			fwrite(item->mData,1,item->mSize,fp);
		}
	}

	fwrite(&value,sizeof(value),1,fp);

	fclose(fp);
}

void DataBase::Load(void)
{
	FILE *fp;

	fp = fopen("c:\\samples.db","rb");

	if (!fp)
	{
		return;
	}

	Clear();

	int size;

	do
	{
		fread(&size,sizeof(size),1,fp);
		if (size >= 0)
		{
			ItemData *item = new ItemData;
			char buffer[256];
			fread(buffer,1,size,fp);
			buffer[size] = 0;
			item->mName = std::string(buffer);

			int sampsize;
			fread(&sampsize,sizeof(sampsize),1,fp);
			item->mSize = sampsize;
			if (item->mSize > 0)
			{
				item->mData = malloc(item->mSize);
				fread(item->mData,1,item->mSize,fp);
			}
			Add(item);
		}
	} while(size != -1 && !feof(fp));

	fclose(fp);
}

void DataBase::Add(ItemData *item)
{
	if (Find(item) >= 0)
	{
		delete item;
		return;
	}

//	printf("DataBase::Add() : Adding an element for %d bytes\n",item->mSize);
	mItems.push_back(item);
}

static bool NotTheSame(void *data1,void *data2,int len)
{
	signed char d1,d2;
	float avdiff = 0;

	for (int i=0;i<len;i++)
	{
		d1 = ((signed char *)data1)[i];
		d2 = ((signed char *)data2)[i];
		avdiff += (float) abs(d1-d2);
	}

	avdiff /= float(len);
	if (avdiff > 5.0f)
	{
		return true;
	}

	return false;
}

int DataBase::Find(ItemData *item)
{
	std::list<ItemData *>::iterator st,en;
	int handle = 0;

	st = mItems.begin();
	en = mItems.end();

	while(st!=en)
	{
		ItemData *litem = *st;

		if (item->mName.compare(litem->mName)==0)
		{
			if (litem->mSize < item->mSize)
			{
				litem->mSize = item->mSize;
				litem->mData = item->mData;
			}
			return handle;
		}
#if 0
		if (item->mSize == 0)
		{
			return handle;
		}

		if (litem->mSize == item->mSize && litem->mSize > 0 && item->mSize > 0)
		{
			if (NotTheSame(litem->mData,item->mData,litem->mSize) == false)
			{
//				printf("DataBase::Find() : Found a perfect match of %d bytes\n",litem->mSize);
				return handle;
			}
		}

		if (item->mSize < litem->mSize && item->mSize > 0 && litem->mSize > 0)
		{
			if (NotTheSame(litem->mData,item->mData,item->mSize) == false)
			{
//				printf("DataBase::Find() : Found a source smaller perfect match of %d bytes\n",item->mSize);
				return handle;
			}
		}

		if (litem->mSize < item->mSize && item->mSize > 0 && litem->mSize > 0)
		{
			if (NotTheSame(litem->mData,item->mData,litem->mSize) == false)
			{
//				printf("DataBase::Find() : Found a source larger perfect match of %d bytes to %d bytes\n",litem->mSize,item->mData);
				litem->mData = item->mData;
				litem->mSize = item->mSize;
				return handle;
			}
		}
#endif

		handle++;
		st++;
	}

	return -1;
}

DataBase::ItemData *DataBase::Iterate(bool begin)
{
	if (begin)
	{
		mIst = mItems.begin();
		mIen = mItems.end();
		return 0;
	}

	if (mIst != mIen)
	{
		ItemData *item = *mIst;
		mIst++;
		return item;
	}
	return 0;
}
