/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "enemybat.h"
#include "bat.h"
#include "firefly.h"
#include "killerturtlesmall.h"
#include "main.h"
#include "samplemanager.h"
#include "particles.h"

batparms Bat[12];
u8 batclock;


const u32 SmallFlyEnemyPalette[10] = {(u32)BatFlyPalette,(u32)FireFlyPalette,(u32)FireFlyPalette,(u32)KTurtleSmallFlyPalette,
										(u32)BatFlyPalette,(u32)BatFlyPalette,(u32)BatFlyPalette,(u32)BatFlyPalette,
										(u32)BatFlyPalette,(u32)BatFlyPalette};

const u32 SFFlySprite[10] = {(u32)BatFlySprite,(u32)FireFlySprite,(u32)FireFlySprite,(u32)KTurtleSmallFlySprite,
							(u32)BatFlySprite,(u32)BatFlySprite,(u32)BatFlySprite,(u32)BatFlySprite,
							(u32)BatFlySprite,(u32)BatFlySprite};
							

const u8 SmallFlySpeed[10] = {2,2,2,1,2,2,2,2,2,2};

const u32 SFOff[10][4] = {0,512,1024,1536,
						  0,512,1024,512,
						  0,512,1024,1536,
						  0,512,1024,1536,
						  0,512,1024,1536,
						  0,512,1024,1536,
						  0,512,1024,1536,
						  0,512,1024,1536,
						  0,512,1024,1536,
						  0,512,1024,1536
						  };
						  
u8 SmallFlyEnemy;

extern s16 game_x;
extern s16 game_y;

u8 NextBat(void)
{
	u8 a;
	for(a = 0; a < 12; a++)
	{
		if(Bat[a].xpos == 0)
		{
			Bat[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void RemoveBat(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	Bat[me].xpos = 0;
}

void initenemybat(void)
{
	u32 i;
	u8 me;
	
	me = NextBat();
	//AGBPrintf("me = %d\n",me);
	//AGBPrintFlush();
	Bat[me].frame = GrabASprite();
	Object[num_strats].handle = HandleBat;
	Object[num_strats].remover = RemoveBat;
	i = Bat[me].frame;
      	Sprite[i].CharNo = EnemySprite[nxtenemy];
   		Sprite[i].Size = BatFlySizeShape[0];
   		Sprite[i].Shape = BatFlySizeShape[1];
   		Sprite[i].Pltt = 3;
         Sprite[i].Priority = 2;
        Bat[me].xpos = parm_xpos;
        Bat[me].ypos = parm_ypos;
        Bat[me].patrolypos = parm_ypos;
        Bat[me].patrollx = parm_xpos;
        Bat[me].patrolrx = wp_xpos; //Object[num_strats].parameter;
 		Bat[me].dx = SmallFlySpeed[SmallFlyEnemy];
		Bat[me].top = parm_ypos; // maximum height
 		Bat[me].bottom = parm_ypos;
 		for(i = parm_xpos; i < wp_xpos; i += 16)
 			Bat[me].bottom = min(ForceOtherCollision(i,parm_ypos),Bat[me].bottom);



	batclock = 0;
	Bat[me].state = BAT_STATE_FLY;
	Object[num_strats].parameter = me;
	//LoadPalette(SmallFlyEnemyPalette[SmallFlyEnemy],3);
}

void HandleBat(void)
{
	u8 me,b;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;
	mysprite = Bat[me].frame;

	if(abs(player.xpos - Bat[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	}

	if(Freeze_Player == 0)
	{
		Bat[me].xpos += Bat[me].dx;
	
		if(Bat[me].xpos < Bat[me].patrollx || Bat[me].xpos > Bat[me].patrolrx)
			Bat[me].dx = -Bat[me].dx;
	}
	sprx = Bat[me].xpos - game_x - 16;
	spry = Bat[me].ypos - game_y + bobtable[batclock] - 16;
	if(sprx >= -64 && sprx < 240 && spry >= -32 && spry < 160)
	{
		CheckEnemyNear(Bat[me].xpos,Bat[me].ypos,0);
		batclock++;
		if(batclock > 15)
			batclock = 0;

		if(player_state != player_state_attack)
		{
			b = 0;
			if(player_state == player_state_duck && Bat[me].ypos < player.ypos)
				b = 32;
		
			if(Bat[me].xpos > player.xpos - 16 && Bat[me].xpos < player.xpos + 16 && Bat[me].ypos > player.ypos - 40 + b && Bat[me].ypos < player.ypos + 16 && Freeze_Player == 0)
			{
				HitPlayer(1);
			}
		}
		LoadEnemyPalette(SmallFlyEnemyPalette[SmallFlyEnemy],nxtenemypal);
   		Sprite[mysprite].Pltt = 2 + PalCache;

		sprite_ptr = (u32)SFFlySprite[SmallFlyEnemy] + SFOff[SmallFlyEnemy][batclock >> 2];
		LoadEnemySprite(sprite_ptr, 512);
   		Sprite[mysprite].Size = BatFlySizeShape[0];
   		Sprite[mysprite].Shape = BatFlySizeShape[1];
         Sprite[mysprite].Priority = 2;
		
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		Sprite[mysprite].AffineMode = 0;
		if(Bat[me].dx >= 0)
			Sprite[mysprite].HFlip = 1;
		else
			Sprite[mysprite].HFlip = 0;
		
		//if(Bat[me].state == BAT_STATE_STUNNED)
		//	Sprite[mysprite].HFlip = 1 - Sprite[mysprite].HFlip;
			
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
	
//	if(Bat[me].state == BAT_STATE_FLY)
	{
			
		if(Game_Level + Game_Difficulty * 2 > 5 && Freeze_Player == 0)
		{ 
			if((abs(player.xpos - Bat[me].xpos) < 128) && (abs(player.ypos - Bat[me].ypos) < 128))
			{
				Bat[me].ypos += smin(player.ypos - 40 - Bat[me].ypos,2);
			}
			else
			{
				Bat[me].ypos += smin(Bat[me].patrolypos - Bat[me].ypos,1);
			}
			
			Bat[me].ypos = min(WaterLevel - 16, Bat[me].ypos);
		}
	}
	
	Bat[me].ypos = max(Bat[me].top,min(Bat[me].bottom,Bat[me].ypos));
	
	if(FrisbeeHit(Bat[me].xpos,Bat[me].ypos,32 ))
	{
		Sample_Play(SMPL_KILL_ENEMY);
		spawn(initbaddyblast,Bat[me].xpos,Bat[me].ypos,0);
		respawnme();
		remove();
		Sprite[mysprite].VPos = 161;
	}

	
	
}

