/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "enemybohrok.h"
#include "bohroksprites.h"
#include "main.h"
#include "SampleManager.h"
#include "particles.h"
#include "switch.h"

u16 currsprite;
u8 frameclock;
bohrokparms Bohrok[16];

const u32 BohrokSprite[5] = {(u32)BohrokWalkSprite,(u32)BohrokHitSprite,(u32)BohrokRunSprite,(u32)BohrokRunSprite,(u32)BohrokRunSprite};
const u32 BohrokOffset[5][8] = {0,2048,2048 * 2,2048 * 3,2048 * 4,2048 * 5,2048 * 6,2048 * 7,
								0,2048,2048 * 2,2048 * 3,2048 * 4,2048 * 5,2048 * 6,2048 * 7,
								0,2048,2048 * 2,2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,
								2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,
								2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,2048 * 3,
								};

const u16 BohrokEyePalette[5] = {0x0015,0x001a,0x001f,0x021f,0x43ff};
const u16 EnemyAttackPalette[16] = {0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f,0x001f};

extern s16 game_x;
extern s16 game_y;


void BlastBohrok(u8 me,u8 f)
{
		spawn(initbaddyblast,Bohrok[me].xpos,Bohrok[me].ypos,0);
		spawn(initbaddyblast,Bohrok[me].xpos,Bohrok[me].ypos,1);
		spawn(initbaddyblast,Bohrok[me].xpos,Bohrok[me].ypos,2);
	//	spawn(initbaddyblast,Bohrok[me].xpos,Bohrok[me].ypos,1);
		Bohrok[me].state = BOHROK_HIT;
		Bohrok[me].health = max(0,Bohrok[me].health - f);
		Bohrok[me].timer = -32 + Game_Difficulty * 8;
		if(Bohrok[me].pal > 2)
			Bohrok[me].timer += 5;
		
		if(Bohrok[me].health > 0)
		{
		
			if(Bohrok[me].xpos == Bohrok[me].patrollx)
			{
				Bohrok[me].dx = 4;
				Bohrok[me].floor = Bohrok[me].floorr;
			}
			else
			{
				Bohrok[me].dx = -4;
				Bohrok[me].floor = Bohrok[me].floorl;
			}
		}
		else
		{
			Sample_Play(SMPL_KILL_ENEMY);
			Bohrok[me].timer = 0;
			Bohrok[me].dx = 0; // Frisbee[Frisbee_Hit].dx;
			if(Bohrok[me].killswitch > 0) // attatched switch
			{
				tswitch[Bohrok[me].killswitch].state = 1;
			}
		}

}


u8 NextBohrok(void)
{
	u8 a;
	for(a = 0; a < 16; a++)
	{
		if(Bohrok[a].xpos == 0)
		{
			Bohrok[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void RemoveBohrok(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	Bohrok[me].xpos = 0;
}

void initenemybohrok(void)
{
	u32 i;
	u8 me;
	u16 parm;
	u8 hits;
	u8 onswitch;
	u8 killswitch;
	u8 jumpstart;
	
	parm = Object[num_strats].parameter;
	
	hits = parm % 10;
	onswitch = (parm / 10) % 100;
	killswitch = (parm / 1000) % 100;
	
	jumpstart = 0;
	if(killswitch >= 32)
	{
		jumpstart = 1;
		killswitch = 0;
	}
	
	me = NextBohrok();
	//Bohrok[me].frame = GrabASprite();
	Object[num_strats].handle = HandleBohrok;
	Object[num_strats].remover = RemoveBohrok;

 
        Bohrok[me].xpos = wp_xpos;
        if(jumpstart == 1)
        	Bohrok[me].ypos = ForceOtherCollision(parm_xpos,parm_ypos);
        else
            Bohrok[me].ypos = ForceOtherCollision(wp_xpos,wp_ypos); // put Bohrok on the floor
        
        Bohrok[me].floor = Bohrok[me].ypos;
        Bohrok[me].ypos += (jumpstart * 64);
        Bohrok[me].patrollx = min(wp_xpos,parm_xpos);
        Bohrok[me].patrolrx = max(wp_xpos,parm_xpos) - jumpstart * 64; // + jumpstart * 64; //Object[num_strats].parameter;
 		Bohrok[me].dx = -1;
 		if(wp_xpos < parm_xpos)
 		{
 			Bohrok[me].dx = 1;
    	     Bohrok[me].patrollx = wp_xpos + jumpstart * 64; // + jumpstart *64;
	        Bohrok[me].patrolrx = parm_xpos; //Object[num_strats].parameter;
			Bohrok[me].floorl = ForceOtherCollision(wp_xpos + jumpstart * 64,wp_ypos);
			Bohrok[me].floorr = ForceOtherCollision(parm_xpos ,parm_ypos) ;

		}
		else
		{
			Bohrok[me].floorl = ForceOtherCollision(parm_xpos,parm_ypos);
			Bohrok[me].floorr = ForceOtherCollision(wp_xpos  - jumpstart * 64,wp_ypos);
		}
 		Bohrok[me].health = max(1,hits) + Game_Difficulty;
 		Bohrok[me].onswitch = onswitch;
 		Bohrok[me].killswitch = killswitch;
	Bohrok[me].clock = 0;
	Bohrok[me].state = BOHROK_WALK;
	if(jumpstart)
		Bohrok[me].state = BOHROK_WAIT;
		
	Bohrok[me].dclock = 1;
	Bohrok[me].preroll = 0;
	
	Bohrok[me].pal = min(2,Bohrok[me].health - 1);
	if(Game_Area + Game_Difficulty > 3)
		Bohrok[me].pal += 3; // super speedy Bohroks

	Object[num_strats].parameter = me;
	//LoadPalette(BohrokWalkPalette,2);
}

void HandleBohrok(void)
{
	u8 me,a,f;
	s16 sprx,spry;
	u32 sprite_ptr;
	u8 mypal;
	
	me = Object[current_strat].parameter;
	
	
	if(Bohrok[me].onswitch > 0)  // this Bohrok is triggered
	{
		if(tswitch[Bohrok[me].onswitch].state == 0)
			return;
	}
	if(abs(player.xpos - Bohrok[me].xpos) > 400)
		return;
		
	if(Bohrok[me].preroll == 0)
		Bohrok[me].xpos += Bohrok[me].dx;
	else
		Bohrok[me].preroll--;
		
	if(Bohrok[me].state < BOHROK_HIT) // stick to ground
		Bohrok[me].ypos = ForceOtherCollision(Bohrok[me].xpos,Bohrok[me].ypos);

	// AI
	
	// If player not spotted, patrol
	// if player in front of bohrok, roll attack him
	// if hit player in roll, recover to patrol
	// if not hit player, recover and wait (vulnernable)
	
	
	switch(Bohrok[me].state)
	{
		case BOHROK_WALK: // patrolling
			//if(Bohrok[me].xpos < Bohrok[me].patrollx || Bohrok[me].xpos > Bohrok[me].patrolrx)
			//	Bohrok[me].dx = -Bohrok[me].dx;
			f = FrisbeeHit(Bohrok[me].xpos,Bohrok[me].ypos,32) | FrisbeeHit(Bohrok[me].xpos,Bohrok[me].ypos - 16,32);
			if(f)		// do nothing when hit (this just knocks the frisbee back)
			{
				if(player.ActionFlags & ACTION_SMARTBOMB) // smartbomb always effective
				{
					BlastBohrok(me,f);
				}
				else
				{
					DiscRebound();
				}
			}
			if(Bohrok[me].state == BOHROK_WALK)
			{
				Bohrok[me].dx = 0;
			//	Bohrok[me].preroll = ;
				if((player.xpos >= Bohrok[me].patrollx && player.xpos <= Bohrok[me].patrolrx && abs(player.ypos - Bohrok[me].ypos) < 64) || (Bohrok[me].preroll == 0))
				{
					Bohrok[me].state = BOHROK_ROLL; // attack player
					Bohrok[me].rolls = 0;
				//	Bohrok[me].dx = smin(player.xpos - Bohrok[me].xpos,3);
				//	if(Bohrok[me].dx == 0)
					{
						if(abs(Bohrok[me].xpos - Bohrok[me].patrollx) < 16)
							Bohrok[me].dx = 3;
						else
							Bohrok[me].dx = -3;
					}
					Bohrok[me].preroll = 30 - Game_Difficulty * 8;
					if(Bohrok[me].pal > 2)
						Bohrok[me].preroll = 15 - Game_Difficulty * 5;
					Bohrok[me].clock = 0;
					Sample_Play(SMPL_BOHROK_SERVO);
				}
			}
			break;
		case BOHROK_WAIT: // jump out of pit
			Bohrok[me].state = BOHROK_REBOUND;
			Bohrok[me].dx = Bohrok[me].dx * 2;
			Bohrok[me].timer = -36;
			if(Bohrok[me].dx < 0)
				Bohrok[me].floor = Bohrok[me].floorl;
			else
				Bohrok[me].floor = Bohrok[me].floorr;
		
		
			break;
		
		case BOHROK_ROLL:	// attacking player

			if(FrisbeeHit(Bohrok[me].xpos,Bohrok[me].ypos,32))		// do nothing when hit (this just knocks the frisbee back)
			{
				if(player.ActionFlags & ACTION_SMARTBOMB) // smartbomb even works on rolling Bohroks
				{
					BlastBohrok(me,f);
				}
				else
				{
					DiscRebound();
				}
			}

			if(Bohrok[me].state == BOHROK_ROLL)
			{
				if(Bohrok[me].xpos > (player.xpos - 16) && Bohrok[me].xpos < (player.xpos + 16) && player.ypos > (Bohrok[me].ypos - 32) && player.ypos < (Bohrok[me].ypos + 48))
				{
					HitPlayer(1);
					Bohrok[me].state = BOHROK_REBOUND;
					Bohrok[me].dx = -Bohrok[me].dx * 2;
					Bohrok[me].timer = -32;
					if(Bohrok[me].dx < 0)
						Bohrok[me].floor = Bohrok[me].floorl;
					else
						Bohrok[me].floor = Bohrok[me].floorr;
				}
				if(Bohrok[me].xpos < Bohrok[me].patrollx || Bohrok[me].xpos > Bohrok[me].patrolrx)
				{
					if(Bohrok[me].pal > 2 && Bohrok[me].rolls < 1)
					{
						Bohrok[me].rolls++;
						Bohrok[me].dx = -Bohrok[me].dx;
					}
					else
					{
						Bohrok[me].state = BOHROK_RECOVER;
						Bohrok[me].dx = 0;
						Bohrok[me].timer = 59;
						Bohrok[me].xpos = max(Bohrok[me].patrollx,min(Bohrok[me].patrolrx,Bohrok[me].xpos));
						if((player.xpos >= Bohrok[me].patrollx && player.xpos <= Bohrok[me].patrolrx && abs(player.ypos - Bohrok[me].ypos) < 64))
							Bohrok[me].timer = 0;
					}
				}	
			}
	
				
			break;
			
		case BOHROK_RECOVER:	// recovering from roll (vulnerable)
			f = FrisbeeHit(Bohrok[me].xpos,Bohrok[me].ypos,32) | FrisbeeHit(Bohrok[me].xpos,Bohrok[me].ypos - 16,32);
			if(f)
			{
				BlastBohrok(me,f);
				
				
			}
			if(Bohrok[me].state == BOHROK_RECOVER)
			{

		//		spawnparticle(Bohrok[me].xpos + (fsin[(GameClock << 3) & 255] >> 3),Bohrok[me].ypos - 48,0,0,0,0,4,2,0);
		//		spawnparticle(Bohrok[me].xpos + (fsin[((GameClock << 3) + 128) & 255] >> 3),Bohrok[me].ypos - 48,0,0,0,0,4,2,0);
				if((GameClock & 3) == 0)
					Bohrok[me].timer++;
				if(Bohrok[me].timer >= 60)
				{
					Bohrok[me].state = BOHROK_WALK;
					Bohrok[me].preroll = 1;
					if(Bohrok[me].xpos < Bohrok[me].patrolrx)
						Bohrok[me].dx = 1;
					else
						Bohrok[me].dx = -1;
				}
			}
			break;
		
		case BOHROK_HIT:		// hit by player
			if(Bohrok[me].health > 0)
			{
				Bohrok[me].xpos = max(Bohrok[me].patrollx,min(Bohrok[me].patrolrx,Bohrok[me].xpos));
				Bohrok[me].ypos	= Bohrok[me].ypos + (Bohrok[me].timer / 4);
				if(Bohrok[me].ypos >= Bohrok[me].floor && Bohrok[me].health > 0)
				{
					Bohrok[me].ypos = Bohrok[me].floor;
					if((GameClock & 7) == 0)
						Bohrok[me].timer++;
					if(Bohrok[me].timer >= 15)
					{
						Bohrok[me].preroll = 60 - Game_Difficulty * 15;
						Bohrok[me].state = BOHROK_WALK;
						if(Bohrok[me].xpos < Bohrok[me].patrolrx)
							Bohrok[me].dx = 1;
						else
							Bohrok[me].dx = -1;
					}
				}
				else
				{
					Bohrok[me].timer = min(16,Bohrok[me].timer + 1);
				}
			}
			else
			{
				//if((GameClock & 7) == 0)
					Bohrok[me].timer++;
				if(Bohrok[me].timer == 15 && CheckBlasts())
				{
					spawn(initbaddyblast,Bohrok[me].xpos + srnd(8),Bohrok[me].ypos + srnd(8),0);
				}
				
				if((Bohrok[me].timer & 7) == 0 && CheckBlasts() )
				{
					spawn(initbaddyblast,Bohrok[me].xpos + srnd(8),Bohrok[me].ypos + srnd(8),1);
				}
				
				if(Bohrok[me].timer >= 15)
				{
					Bohrok[me].xpos = -1;
					Bohrok[me].state = BOHROK_WALK;
				}
			}	
			
			break;
		case BOHROK_REBOUND:		//  bounced off player
			Bohrok[me].preroll = 0;
			Bohrok[me].xpos = max(Bohrok[me].patrollx,min(Bohrok[me].patrolrx,Bohrok[me].xpos));
			Bohrok[me].ypos	= Bohrok[me].ypos + (Bohrok[me].timer / 4);
			if(Bohrok[me].ypos >= Bohrok[me].floor && Bohrok[me].timer > 0)
			{
				Bohrok[me].ypos = Bohrok[me].floor;
				if((GameClock & 7) == 0)
					Bohrok[me].timer++;
				if(Bohrok[me].timer >= 15)
				{
					Bohrok[me].state = BOHROK_WALK;
				Bohrok[me].preroll = 60 - Game_Difficulty * 15;
					if(Bohrok[me].xpos < Bohrok[me].patrolrx)
						Bohrok[me].dx = 1;
					else
						Bohrok[me].dx = -1;
				}
			}
			else
			{
				Bohrok[me].timer = min(16,Bohrok[me].timer + 1);
			}
				
			
			break;
	}


	sprx = Bohrok[me].xpos - game_x - 32;
	spry = Bohrok[me].ypos - game_y  - 48;
	CheckEnemyNear(Bohrok[me].xpos,Bohrok[me].ypos,1);
	if(sprx >= -64 && sprx < 240 && spry >= -64 && spry < 160)
	{
		mysprite = NextSprite; // Bohrok[me].frame;
   		
   		NextSprite += 1;
   		
   		Sprite[mysprite].Size = BohrokWalkSizeShape[0];
   		Sprite[mysprite].Shape = BohrokWalkSizeShape[1];
    	Sprite[mysprite].Priority = 2;
	
		
		if(Bohrok[me].state == BOHROK_WALK)
		{
			Bohrok[me].clock += Bohrok[me].dclock;
			if(Bohrok[me].clock == 0)
				Bohrok[me].dclock = 1;
			if(Bohrok[me].clock == 39)
				Bohrok[me].dclock = -1;
				
		}
		else
		{
			Bohrok[me].clock+= 2;
			a = 64;
			if(Bohrok[me].state == BOHROK_RECOVER)
				a = 56;
			
			if(Bohrok[me].clock >= a)
			{
				if(Bohrok[me].state >= BOHROK_ROLL)
					Bohrok[me].clock = 32;
				else 
					Bohrok[me].clock = 0;
			}
		}
	//	if((Bohrok[me].clock & 3) == 0)
	//	{
			mypal = Bohrok[me].pal;
			sprite_ptr = BohrokSprite[Bohrok[me].state] + BohrokOffset[Bohrok[me].state][Bohrok[me].clock >> 3];
			LoadEnemySprite(sprite_ptr, BOHROK_SPRITE_SIZE);
	
			if(Bohrok[me].state == BOHROK_HIT && ((Bohrok[me].clock & 8) != 0))
			{
				LoadEnemyPalette(VFlashPalette,nxtenemypal);
			}
			else
			{
				LoadEnemyPalette(BohrokWalkPalette[mypal],nxtenemypal);
				LoadEnemyCyclePalette(&BohrokEyePalette[(Bohrok[me].clock >> 2) % 3],nxtenemypal);
	   		}
	   		Sprite[mysprite].Pltt = 2 + PalCache;
	//	}
		
		if(Bohrok[me].dx == 0)
		{
			if(player.xpos > Bohrok[me].xpos)
				Sprite[mysprite].HFlip = 0;
			else
				Sprite[mysprite].HFlip = 1;
		}
		else
		{
		
			if(Bohrok[me].dx > 0)
				Sprite[mysprite].HFlip = 0;
			else
				Sprite[mysprite].HFlip = 1;
		}
		if(Bohrok[me].state >= BOHROK_ROLL && Bohrok[me].clock > 31)
		{
	  		Sprite[mysprite].AffineMode = 3; // 0 off 3 on and double size
			sprx -= 32;
			spry -=20;
			if(Bohrok[me].dx > 0)
	   		{
	   			 Sprite[mysprite].AffineParamNo_L = 1; // use affine 1 (roll left) and 2 (roll right)
				SpriteRotate(1,(rotateclock * 2) & 255);
			}
			else
	   		{
	   			Sprite[mysprite].HFlip = 0;
	   			Sprite[mysprite].AffineParamNo_L = 2; // use affine 1 (roll left) and 2 (roll right)
				SpriteRotate(2,(rotateclock2 * 2) & 255);
			
			}
		}
		else
		{
			Sprite[mysprite].AffineMode = 0;
		}
		
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		if(((GameClock & 3) == 0) && (Bohrok[me].state == BOHROK_ROLL))
		{
			inittrailsprite(Bohrok[me].xpos - 32,Bohrok[me].ypos - 36,EnemySprite[SpriteCache],BohrokWalkSizeShape[0],BohrokWalkSizeShape[1],2 + PalCache);
			// spawn smoke
			if((GameClock & 3) == 0)
				 spawnparticle(Bohrok[me].xpos - 16,Bohrok[me].ypos ,0,0,-Bohrok[me].dx,-2,16,50,0);
	
		}

	
	}
	else
	{
		if(Bohrok[me].health == 0)
		{
			respawnme();
			remove();
		}
	}
}

void initloaderbohroks(void)  // spins across loading screen
{
	u32 i;
	u8 me;
	
	me = 0;

 
	//LoadPalette(BohrokWalkPalette,2);
}

void HandleLoaderBohrok(s16 clock)
{
	u8 me,a,f;
	s16 sprx,spry;
	u32 sprite_ptr;
	u8 mypal;
	
	me = 0;
	
	sprx = 240 - clock * 2;
	spry = -16;
	a = 255 - (clock * 16);
	nxtenemy = 0;
	if(sprx >= -64 && sprx < 240)
	{
		mysprite = 96; // Bohrok[me].frame;
   		
   		Sprite[mysprite].Size = BohrokWalkSizeShape[0];
   		Sprite[mysprite].Shape = BohrokWalkSizeShape[1];
    	Sprite[mysprite].Priority = 0;
	
		
		mypal = Game_Area;
		sprite_ptr = BohrokSprite[BOHROK_ROLL] + BohrokOffset[BOHROK_ROLL][4];
		LoadEnemySprite(sprite_ptr, BOHROK_SPRITE_SIZE);
		LoadEnemyPalette(BohrokWalkPalette[mypal],nxtenemypal);
	   	Sprite[mysprite].Pltt = 2 + PalCache;
		Sprite[mysprite].HFlip = 0;
		Sprite[mysprite].HFlip = 1;
  		Sprite[mysprite].AffineMode = 3; // 0 off 3 on and double size
		sprx -= 32;
		spry -=20;
		Sprite[mysprite].HFlip = 0;
		Sprite[mysprite].AffineParamNo_L = 2; // use affine 1 (roll left) and 2 (roll right)
		SpriteRotateScale(2,a,4,4);
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
	}
}


