/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "enemymonkey.h"
#include "monkey.h"
#include "main.h"
#include "ammobanana.h"
#include "scorpion.h"
#include "landgrabber.h"
#include "doberman.h"
#include "dodo.h"
#include "samplemanager.h"
#include "particlesprites.h"
#include "particles.h"


extern u16 BohrokEyePalette[5];
extern u16 EnemyAttackPalette[16];

u16 currsprite;
u8 frameclock;
monkeyparms monkey[8];
coconutparms coconut[8];

const u32 AmmoSprite[6] = {(u32)Particle2Sprite + 512,(u32)Particle2KoSprite + 512,(u32)Particle2TaSprite + 512,(u32)Particle2PoSprite + 512,(u32)Particle2GaSprite + 512,(u32)Particle2OnuSprite + 512};

const u32 BigGPalette[6] = {(u32)MonkeyWalkPalette,(u32)ScorpionWalkPalette,(u32)LGrabberWalkPalette,(u32)DobermanWalkPalette,(u32)DodoWalkPalette,(u32)DodoWalkPalette};


const u32 BigGWalkSprite[6] = {(u32)MonkeyWalkSprite,(u32)ScorpionWalkSprite,(u32)LGrabberWalkSprite,(u32)DobermanWalkSprite,(u32)DodoWalkSprite,(u32)DodoWalkSprite};

const u32 BigGAttackSprite[6] = {(u32)MonkeyAttackSprite,(u32)ScorpionAttackSprite,(u32)LGrabberWalkSprite,(u32)DobermanAttackSprite,(u32)DodoWalkSprite,(u32)DodoWalkSprite};

const u8 BWFrames[6] = {8,4,6,8,4,8};

u8 BigWalkEnemy;

u8 monkeyclock;
u8 monkeyframe;

extern s16 game_x;
extern s16 game_y;

u8 NextMonkey(void)
{
	u8 a;
	for(a = 0; a < 8; a++)
	{
		if(monkey[a].xpos == 0)
		{
			monkey[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

u8 RemoveMonkey(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	monkey[me].xpos = 0;
}

void initenemymonkey(void)
{
	u32 i;
	u8 me;
	
	me = NextMonkey();
	//AGBPrintf("me = %d\n",me);
	//AGBPrintFlush();
	monkey[me].frame = GrabASprite();
	Object[num_strats].handle = HandleMonkey;
	Object[num_strats].remover = RemoveMonkey;
	i = monkey[me].frame;
      	Sprite[i].CharNo = EnemySprite[nxtenemy];
   		Sprite[i].Size = MonkeyWalkSizeShape[0];
   		Sprite[i].Shape = MonkeyWalkSizeShape[1];
   		Sprite[i].Pltt = 3;
         Sprite[i].Priority = 2;
         parm_ypos = ForceOtherCollision(parm_xpos,parm_ypos);
        monkey[me].xpos = parm_xpos;
        monkey[me].ypos = parm_ypos;
        monkey[me].patrolypos = parm_ypos;
        monkey[me].patrollx = parm_xpos;
        monkey[me].patrolrx = wp_xpos; //Object[num_strats].parameter;
 		monkey[me].dx = 1;
	monkeyclock = 0;
	monkey[me].state = MONKEY_STATE_WALK;
	monkey[me].hits = max(1,Object[num_strats].parameter) + Game_Difficulty;
	Object[num_strats].parameter = me;
//	LoadPalette(BigGPalette[BigWalkEnemy],3);
}

void HandleMonkey(void)
{
	u8 me,f;
	s16 sprx,spry;
	u32 sprite_ptr;
	 
	me = Object[current_strat].parameter;

	mysprite = monkey[me].frame;

	if(abs(player.xpos - monkey[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	}
	if(Freeze_Player == 0)
	{
		if(monkey[me].stuntime < 210 || monkey[me].state == MONKEY_STATE_WALK || monkey[me].state == MONKEY_STATE_ATTACK2)
		{
			monkey[me].xpos += monkey[me].dx;
		}
	}
	spry = ForceOtherCollision(monkey[me].xpos,monkey[me].ypos);
	if(abs(spry - monkey[me].ypos) < 16)
		monkey[me].ypos = spry;
	else
		monkey[me].ypos += smin(spry - monkey[me].ypos,1);
		
	if(monkey[me].stuntime > 0)
		monkey[me].stuntime--;

	if(monkey[me].state >= MONKEY_STATE_STUNNED)
	{
		if(monkey[me].stuntime == 0)
		{
			monkey[me].state = MONKEY_STATE_WALK;
			monkey[me].dx = smin(monkey[me].dx,1);
		}
	}
	
	if(monkey[me].xpos < monkey[me].patrollx || monkey[me].xpos > monkey[me].patrolrx)
	{
		monkey[me].dx = smin(-monkey[me].dx,1);
		monkey[me].xpos = max(monkey[me].patrollx,min(monkey[me].patrolrx,monkey[me].xpos));
		if(monkey[me].state == MONKEY_STATE_ATTACK2)
		{
			monkey[me].state = MONKEY_STATE_WALK;
			monkey[me].stuntime = 0;
		}
	}
	sprx = monkey[me].xpos - game_x - 32;
	spry = monkey[me].ypos - game_y - 40; // + bobtable[monkeyclock] - 16;
	if(sprx >= -64 && sprx < 240 && spry >= -32 && spry < 160)
	{
	//	CheckEnemyNear(monkey[me].xpos,monkey[me].ypos,0);
		
		monkeyclock++;
		
		if(monkey[me].state == MONKEY_STATE_ATTACK2)
		{
			if((monkeyclock & 1) == 0)
			{
				monkeyframe = (monkeyframe + 1) % BWFrames[BigWalkEnemy];
			}
		}
		else
		{
			if((monkeyclock & 7) == 0)
			{
				monkeyframe = (monkeyframe + 1) % BWFrames[BigWalkEnemy];
			}
		}
		monkeyclock &= 31;
		if(monkeyclock == 31 && monkey[me].state < MONKEY_STATE_STUNNED)
			monkey[me].state = MONKEY_STATE_WALK;
		if(monkeyclock == 16 && monkey[me].state == MONKEY_STATE_ATTACK)
		{
			LoadSprite((u32)AmmoSprite[Game_Area],AMMO_SPRITE_OFFSET,128);
			Sample_Play(SMPL_MBOY_SERVO);
			spawn(initcoconut,monkey[me].xpos,monkey[me].ypos - 36,monkey[me].dx * 2);
		//	monkey[me].state = MONKEY_STATE_WALK;
		//	monkey[me].attackflash = 7;
		}
	//	if((monkeyclock & 7) == 0 || EnemySprite[nxtenemy] != ENEMY_MONKEY)
		{
			//if(EnemySprite[nxtenemy] != ENEMY_MONKEY)
			if(monkey[me].state == MONKEY_STATE_STUNNED  && ((monkey[me].stuntime & 8) == 0) )
			{
				LoadEnemyPalette(VFlashPalette,nxtenemypal);
			}
			else
			{
			//	if(monkey[me].attackflash > 0)
			//	{
			//		LoadEnemyPalette(EnemyAttackPalette,nxtenemypal);
			//		monkey[me].attackflash--;
			//	}
			//	else
			//	{
					LoadEnemyPalette(BigGPalette[BigWalkEnemy],nxtenemypal);
					LoadEnemyCycle2Palette(&BohrokEyePalette[(monkeyclock >> 2) % 3],nxtenemypal);
		   	//	}
		   	}
		   	Sprite[mysprite].Pltt = 2 + PalCache;

		//	EnemySprite[nxtenemy] = ENEMY_MONKEY;
			if(monkey[me].state != MONKEY_STATE_ATTACK)
				sprite_ptr = (u32)BigGWalkSprite[BigWalkEnemy] + monkeyframe * 2048;
			else
				sprite_ptr = (u32)BigGAttackSprite[BigWalkEnemy]; // + (monkeyframe >> 1) * 2048;
				
			LoadEnemySprite(sprite_ptr, 2048);
		}
		
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		
		if(monkey[me].dx >= 0)
			Sprite[mysprite].HFlip = 0;
		else
			Sprite[mysprite].HFlip = 1;
		
	//	if(monkey[me].state == MONKEY_STATE_STUNNED)
		//	Sprite[mysprite].HFlip = 1 - Sprite[mysprite].HFlip;

		
			
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
	
	f = FrisbeeHit(monkey[me].xpos,monkey[me].ypos,32);
	if(f > 0 && (monkey[me].stuntime < 230))
	{
		spawn(initbaddyblast,monkey[me].xpos,monkey[me].ypos,2);
		spawn(initbaddyblast,monkey[me].xpos,monkey[me].ypos,1);
		Sample_Play(SMPL_MBOY_SERVO02);
		monkey[me].state = MONKEY_STATE_STUNNED;
		monkey[me].stuntime = 60;
		monkey[me].hits-=f;
		monkey[me].xpos = max(monkey[me].patrollx + 1,min(monkey[me].patrolrx - 1,monkey[me].xpos + Frisbee[Frisbee_Hit].dx *2));  // impact
		if(monkey[me].hits <= 0)
		{
			Sample_Play(SMPL_KILL_ENEMY);
			spawn(initbaddyblast,monkey[me].xpos,monkey[me].ypos,0);
			respawnme();
			remove();
			Sprite[mysprite].VPos = 161; // return to pool
		}

	}

	if(abs(player.xpos - monkey[me].xpos) < 20 && player.ypos > (monkey[me].ypos - 32) && player.ypos < (monkey[me].ypos + 32) && monkey[me].state != MONKEY_STATE_STUNNED && Freeze_Player == 0)
		HitPlayer(1);	


	if(monkey[me].state == MONKEY_STATE_WALK)
	{
			
		sprx = abs(player.xpos - monkey[me].xpos);	
		if(BigWalkEnemy == 2 || BigWalkEnemy == 5) // rush attack instead of throw...
		{
			if((sprx < 128 && monkey[me].stuntime == 0) && Freeze_Player == 0 && rndfast(127) < (8 - (sprx >> 5)))
			{
				monkey[me].dx = smin(player.xpos + player.dx - monkey[me].xpos,1) * 3;
				monkey[me].state = MONKEY_STATE_ATTACK2;
				monkey[me].stuntime = 60;
				monkeyclock = 0;
			}
		}
		else
		{
			if((sprx < 128 && monkey[me].stuntime == 0) || (sprx < 64 && monkey[me].stuntime < 200) && Freeze_Player == 0)
			{
				monkey[me].dx = smin(player.xpos + player.dx - monkey[me].xpos,1);
				monkey[me].state = MONKEY_STATE_ATTACK;
				monkey[me].stuntime = 255;
				monkeyclock = 0;
				if(sprx < 64)
					monkeyclock = 15;
			}
		}
	}

	
	
}

u8 NextCoconut(void)
{
	u8 a;
	for(a = 0; a < 8; a++)
	{
		if(coconut[a].xpos == 0)
		{
			coconut[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void removecoconut(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	coconut[me].xpos = 0;
}

void initcoconut(void)
{
	u8 me;
	me = NextCoconut();
	Object[num_strats].handle = HandleCoconut;
	Object[num_strats].remover = removecoconut;
	coconut[me].frame = GrabASprite();
	coconut[me].xpos = parm_xpos;
	coconut[me].ypos = parm_ypos;
	coconut[me].dx = Object[num_strats].parameter;
	coconut[me].dy = smin(player.ypos + player.jump - 36 - parm_ypos,2);
    Sprite[coconut[me].frame] = *(OamData *)OamData_Sample;
	Sprite[coconut[me].frame].Size = 1;
	Sprite[coconut[me].frame].Shape = 0;
	Sprite[coconut[me].frame].Pltt = 15;
    Sprite[coconut[me].frame].Priority = 2;
    Object[num_strats].parameter = me;
    

}

void HandleCoconut(void)
{
	u8 me;
	u8 frame;
	s16 sprx,spry;
	
	me = Object[current_strat].parameter;
	coconut[me].xpos += coconut[me].dx;
	coconut[me].ypos += coconut[me].dy;
	
	frame = coconut[me].frame;
	sprx = coconut[me].xpos - 4 - game_x;
	spry = coconut[me].ypos - 4 - game_y;
	
	if(sprx > -32 && sprx < 260 && spry > -8 && spry < 160 && Freeze_Player == 0)
	{
		Sprite[frame].VPos = (spry + 256) & 255;
		Sprite[frame].HPos = sprx & 511;
		Sprite[frame].CharNo = AMMO_SPRITE;
		if(coconut[me].xpos > player.xpos - 16 && coconut[me].xpos <= player.xpos + 16 && coconut[me].ypos > player.ypos - 48 && coconut[me].ypos < player.ypos)
		{
			if(!(player.ActionFlags & ACTION_DUCKED))
			{
				HitPlayer(1);
				coconut[me].xpos -= 256; // force it to remove next frame
			}
		}
	}
	else
	{
		Sprite[frame].VPos = 161;
		remove();
	}

}
