/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "enemynuirama.h"
#include "nfly.h"
#include "BigFireFly.h"
#include "GrabSwimFly.h"
#include "Killerturtlefly.h"
#include "SnakeCobraFly.h"

#include "main.h"
#include "samplemanager.h"
#include "particles.h"

extern u16 BohrokEyePalette[5];

nuiramaparms NuiRama[8];
u8 nuiramaclock;

const u32 BigFlyEnemyPalette[10] = {(u32)NFlyPalette,(u32)BigFireFlyPalette,(u32)GrabSwimFlyPalette,(u32)KillerTurtleFlyPalette,(u32)GrabSwimFlyPalette,
										(u32)NFlyPalette,(u32)NFlyPalette,(u32)NFlyPalette,(u32)NFlyPalette,
										(u32)NFlyPalette};

const u32 BFFlySprite[10] = {(u32)NFlySprite,(u32)BigFireFlySprite,(u32)GrabSwimFlySprite,(u32)KillerTurtleFlySprite,
							(u32)GrabSwimFlySprite,(u32)NFlySprite,(u32)NFlySprite,(u32)NFlySprite,
							(u32)NFlySprite,(u32)NFlySprite};
							
const u32 BFAttackSprite[10] = {(u32)NAttackSprite,(u32)BigFireAttackSprite,(u32)GrabSwimAttackSprite,(u32)KillerTurtleFlySprite,
								(u32)GrabSwimAttackSprite,(u32)NAttackSprite,(u32)NAttackSprite,(u32)NAttackSprite,
								(u32)NAttackSprite,(u32)NAttackSprite,};

const u8 BigFlySpeed[10] = {2,2,1,1,1,2,2,2,2,2};

const u8 BFFrames[10] = {16,16,16,16,16,16,16,16,16};
								
const u16 BFOff[10][6] = {0,2048,4096,6144,0,0,
						  0,2048,4096,2048,0,0,
						  0,2048,4096,6144,0,0,
						  0,2048,4096,6144,0,0,
						  0,2048,4096,6144,8192,10240,
  						  0,2048,4096,6144,0,0,
						  0,2048,4096,6144,0,0,
						  0,2048,4096,6144,0,0,
						  0,2048,4096,6144,0,0,
						  };

													  
u8 BigFlyEnemy;


s8 NuiRamaNoise;
s8 NuiRamaNoiseOwner;

extern s16 game_x;
extern s16 game_y;

u8 NextNuiRama(void)
{
	u8 a;
	for(a = 0; a < 8; a++)
	{
		if(NuiRama[a].xpos == 0)
		{
			NuiRama[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void RemoveNuiRama(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	if(NuiRamaNoise > -1)
	{
		if(NuiRamaNoiseOwner == me)
		{
			Sample_StopLoop(NuiRamaNoise);
			NuiRamaNoise = -1;
			NuiRamaNoiseOwner = -1;
		}
	}
	NuiRama[me].xpos = 0;
}

void initenemynuirama(void)
{
	u32 i;
	u8 me;
	
	me = NextNuiRama();
	//AGBPrintf("me = %d\n",me);
	//AGBPrintFlush();
//	NuiRama[me].frame = GrabASprite();
	Object[num_strats].handle = HandleNuiRama;
	Object[num_strats].remover = RemoveNuiRama;

	NuiRamaNoise = -1;
	NuiRamaNoiseOwner = -1;	
        NuiRama[me].xpos = parm_xpos;
        NuiRama[me].ypos = parm_ypos;
        NuiRama[me].patrollx = parm_xpos;
        NuiRama[me].patrolrx = wp_xpos; // Object[num_strats].parameter;
        NuiRama[me].patrolypos = parm_ypos;
 		NuiRama[me].dx = BigFlySpeed[BigFlyEnemy];
 		NuiRama[me].stuntime = 0;
 		NuiRama[me].hlimit = wp_ypos;
 		NuiRama[me].top = parm_ypos; // maximum height
 		NuiRama[me].bottom = parm_ypos;
 		for(i = parm_xpos; i < wp_xpos; i += 16)
 			NuiRama[me].bottom = min(ForceOtherCollision(i,parm_ypos),NuiRama[me].bottom);
 		
	nuiramaclock = 0;
	NuiRama[me].hits = max(1,Object[num_strats].parameter) + Game_Difficulty;
	NuiRama[me].state = NUI_STATE_FLY;
	Object[num_strats].parameter = me;
	//LoadPalette(NFlyPalette,3);
}

void HandleNuiRama(void)
{
	u8 me,b,f;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;

	if(abs(player.xpos - NuiRama[me].xpos) > 400)
	{
		if(NuiRamaNoise > -1)
		{
			if(NuiRamaNoiseOwner == me)
			{
				Sample_StopLoop(NuiRamaNoise);
				NuiRamaNoise = -1;
				NuiRamaNoiseOwner = -1;
			}
		}
		return;
	}
	if(GameStateLoop == PauseLoop)
	{
		if(NuiRamaNoise > -1)
		{
			if(NuiRamaNoiseOwner == me)
			{
				Sample_StopLoop(NuiRamaNoise);
				NuiRamaNoise = -1;
				NuiRamaNoiseOwner = -1;
			}
		}
	}
	if( Freeze_Player == 0)
	{
		NuiRama[me].xpos += NuiRama[me].dx;
		
		
		if(NuiRama[me].state == NUI_STATE_STUNNED)
		{
			NuiRama[me].stuntime--;
			if(NuiRama[me].stuntime == 0)
			{
				NuiRama[me].state = NUI_STATE_FLY;
			}
		}
	}
	if(NuiRama[me].state != NUI_STATE_DEAD)
	{
		if(NuiRama[me].xpos < NuiRama[me].patrollx || NuiRama[me].xpos > NuiRama[me].patrolrx)
			NuiRama[me].dx = -NuiRama[me].dx;

		sprx = NuiRama[me].xpos - game_x - 32;
		spry = NuiRama[me].ypos - game_y + bobtable[nuiramaclock] - 16;
	}
	else
	{
		spry = 999; // while dead, force off screen
	}
	
	if(sprx >= -64 && sprx < 240 && spry >= -32 && spry < 160)
	{
		mysprite = NextSprite++;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
   		Sprite[mysprite].Size = NFlySizeShape[0];
   		Sprite[mysprite].Shape = NFlySizeShape[1];
   		Sprite[mysprite].Pltt = 3;
         Sprite[mysprite].Priority = 2;
		Sprite[mysprite].AffineMode = 0;

		CheckEnemyNear(NuiRama[me].xpos,NuiRama[me].ypos,0);
		nuiramaclock++;
		if(nuiramaclock >= BFFrames[BigFlyEnemy])
			nuiramaclock = 0;
		
	//	if(((GameClock % 12) == 0) && BigFlyEnemy < 2)
		if(NuiRamaNoise == -1)
		{	
			NuiRamaNoise = Sample_PlayLoop(SMPL_NUI_RAMA_FLAP);
			NuiRamaNoiseOwner = me;
		}	
		if(nuiramaclock == (BFFrames[BigFlyEnemy] - 1) && NuiRama[me].state != NUI_STATE_STUNNED)
		{
			NuiRama[me].state = NUI_STATE_FLY;
		}
		if(NuiRama[me].state != NUI_STATE_STUNNED)
		{
			if(player_state != player_state_attack)
			{
				b = 0;
				if(player_state == player_state_duck && NuiRama[me].ypos < player.ypos)
				{
					b = 32;
				}
				if((abs(player.xpos - NuiRama[me].xpos) < 20) && NuiRama[me].ypos > player.ypos + b - 40 && NuiRama[me].ypos < player.ypos - 16 && Freeze_Player == 0)
				{
					HitPlayer(1);
				}
			}
		}
		if(NuiRama[me].state == NUI_STATE_STUNNED && (NuiRama[me].stuntime & 8) == 0)
		{
			LoadEnemyPalette(VFlashPalette,nxtenemypal);
		}
		else
		{
			LoadEnemyPalette(BigFlyEnemyPalette[BigFlyEnemy],nxtenemypal);
			LoadEnemyCycle2Palette(&BohrokEyePalette[(nuiramaclock >> 2) % 3],nxtenemypal);
   		}
   		Sprite[mysprite].Pltt = 2 + PalCache;

	//	EnemySprite[nxtenemy] = ENEMY_NUIRAMA;
	//	if(NuiRama[me].state != NUI_STATE_ATTACK)
			sprite_ptr = (u32)BFFlySprite[BigFlyEnemy] + BFOff[BigFlyEnemy][nuiramaclock >> 2];
	//	else
	//		sprite_ptr = (u32)BFAttackSprite[BigFlyEnemy] + BFOff[BigFlyEnemy][nuiramaclock >> 2];
			
		LoadEnemySprite(sprite_ptr, ENEMY_SPRITE_SIZE);
		
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;

		if(NuiRama[me].dx >= 0)
			Sprite[mysprite].HFlip = 1;
		else
			Sprite[mysprite].HFlip = 0;
			
	}
	else
	{
		if(NuiRamaNoise > -1)
		{
			if(NuiRamaNoiseOwner == me)
			{
				Sample_StopLoop(NuiRamaNoise);
				NuiRamaNoise = -1;
				NuiRamaNoiseOwner = -1;
			}
		}
	}
	
	f =FrisbeeHit(NuiRama[me].xpos,NuiRama[me].ypos + 12,32);
	if(f > 0 && NuiRama[me].stuntime == 0)
	{
			
		Sample_Play(SMPL_NUI_RAMA_HITSERVO);	
		spawn(initbaddyblast,NuiRama[me].xpos,NuiRama[me].ypos,2);
		spawn(initbaddyblast,NuiRama[me].xpos,NuiRama[me].ypos,1);
		spawn(initbaddyblast,NuiRama[me].xpos,NuiRama[me].ypos,0);
	
		NuiRama[me].state = NUI_STATE_STUNNED;
		NuiRama[me].stuntime = 60;
		NuiRama[me].hits-=f;
		NuiRama[me].xpos = max(NuiRama[me].patrollx + 1,min(NuiRama[me].patrolrx - 1,NuiRama[me].xpos + Frisbee[Frisbee_Hit].dx));  // impact
		
		if(NuiRama[me].hits <= 0)
		{
			Sample_Play(SMPL_KILL_ENEMY);
		//	Sprite[mysprite].VPos = 161; // back to the pool
			if(NuiRamaNoise > -1)
			{
				if(NuiRamaNoiseOwner == me)
				{
					Sample_StopLoop(NuiRamaNoise);
					NuiRamaNoise = -1;
					NuiRamaNoiseOwner = -1;
				}
			}
			respawnme();
			remove();
			
		}
	

	}
	if(NuiRama[me].state == NUI_STATE_FLY && Freeze_Player == 0)
	{
			
		if((abs(player.xpos - NuiRama[me].xpos) < 128) && (abs(player.ypos - NuiRama[me].ypos) < 128))
		{
			NuiRama[me].ypos += smin(player.ypos - 32 - NuiRama[me].ypos,BigFlySpeed[BigFlyEnemy]);
		}
		else
		{
			NuiRama[me].ypos += smin(NuiRama[me].patrolypos - NuiRama[me].ypos,1);
		}
		
		if((abs(player.xpos - NuiRama[me].xpos) < 64) && (abs(player.ypos - NuiRama[me].ypos) < 64))
		{
			NuiRama[me].state = NUI_STATE_ATTACK;
			nuiramaclock = 31;
		}
		
		if(BigFlySpeed[BigFlyEnemy] == 1) // water enemy
		{
			NuiRama[me].ypos = max(NuiRama[me].hlimit + 16,NuiRama[me].ypos);
		}
	//	else
	//	{
		//	NuiRama[me].ypos = min(NuiRama[me].hlimit - 16,NuiRama[me].ypos);
	//	}
	}
	NuiRama[me].ypos = max(NuiRama[me].top,min(NuiRama[me].bottom,NuiRama[me].ypos));
	
	
}

