/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "enemyspider.h"
#include "spider.h"
#include "main.h"

#include "smallturtle.h"
#include "smallfrog.h"
#include "samplemanager.h"
#include "particles.h"


u16 currsprite;
u8 frameclock;
spiderparms spider[16];

const u32 SmallGPalette[6] = {(u32)SpiderWalkPalette,(u32)SFrogWalkPalette,(u32)STurtleWalkPalette,(u32)SpiderWalkPalette,(u32)SpiderWalkPalette,(u32)SpiderWalkPalette};


const u32 SmallGWalkSprite[6] = {(u32)SpiderWalkSprite,(u32)SFrogWalkSprite,(u32)STurtleWalkSprite,(u32)SpiderWalkSprite,(u32)SpiderWalkSprite,(u32)SpiderWalkSprite};


const u8 SmallWalkMove[6] = {0,1,0,0,0,0}; // frog hops

const u8 SmallWalkFrames[6] = {4,3,4,4,4,4}; // frames to cycle

u8 SmallWalkEnemy;


extern s16 game_x;
extern s16 game_y;

u8 NextSpider(void)
{
	u8 a;
	for(a = 0; a < 16; a++)
	{
		if(spider[a].xpos == 0)
		{
			spider[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void RemoveSpider(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	spider[me].xpos = 0;
}

void initenemyspider(void)
{
	u32 i;
	u8 me;
	
	me = NextSpider();
	//AGBPrintf("me = %d\n",me);
	//AGBPrintFlush();
	spider[me].frame = GrabASprite();
	Object[num_strats].handle = HandleSpider;
	Object[num_strats].remover = RemoveSpider;
	i = spider[me].frame;
      	Sprite[i].CharNo = EnemySprite[nxtenemy];
   		Sprite[i].Size = SpiderWalkSizeShape[0];
   		Sprite[i].Shape = SpiderWalkSizeShape[1];
   		Sprite[i].Pltt = 3;
         Sprite[i].Priority = 2;
         parm_ypos = ForceOtherCollision(parm_xpos,parm_ypos);
        spider[me].xpos = parm_xpos;
        spider[me].ypos = parm_ypos;
        spider[me].patrolypos = parm_ypos;
        spider[me].patrollx = parm_xpos;
        spider[me].patrolrx = wp_xpos; //Object[num_strats].parameter;
 		spider[me].dx = 1;
 		spider[me].dy = 0;
	spider[me].clock = 0;
	Object[num_strats].parameter = me;
//	LoadPalette(BigGPalette[BigWalkEnemy],3);
}

void HandleSpider(void)
{
	u8 me;
	s16 sprx,spry;
	u32 sprite_ptr;
	 
	me = Object[current_strat].parameter;
	mysprite = spider[me].frame;
	
	if(abs(player.xpos - spider[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	}
	
	spry = ForceOtherCollision(spider[me].xpos,spider[me].ypos);

	if(Freeze_Player == 0)
	{
		if(SmallWalkMove[SmallWalkEnemy] == 0)
		{
			// normal walk
			spider[me].xpos += spider[me].dx;
			if(abs(spry - spider[me].ypos) < 16)
				spider[me].ypos = spry;
			else
				spider[me].ypos += smin(spry - spider[me].ypos,1);
		}
		else
		{
			// hop
			if((spider[me].clock / 6) == 1) // jump frame
			{
				spider[me].xpos += spider[me].dx;
				if(spider[me].clock == 6)
				{
					spider[me].dy = -7;
					spider[me].clock = 7;
				}
				else
				{
					spider[me].dy++;
				}	
				spider[me].ypos = min(spry, spider[me].ypos + spider[me].dy);
				if(spider[me].ypos >= spry)
				{
					spider[me].clock = 12; // next frame
					spider[me].ypos = spry;
				}
				
			}
			else
			{
				if(abs(spry - spider[me].ypos) < 16)
					spider[me].ypos = spry;
				else
					spider[me].ypos += smin(spry - spider[me].ypos,1);
				if(spider[me].clock < 6 || (GameClock & 3) == 0)
					spider[me].clock++;
				if(spider[me].clock == 18)
					spider[me].clock = 0;
			}
		}
		if(spider[me].xpos < spider[me].patrollx || spider[me].xpos > spider[me].patrolrx)
			spider[me].dx = -spider[me].dx;
	}	
	

	sprx = spider[me].xpos - game_x - 16;
	spry = spider[me].ypos - game_y - 20; // + bobtable[spiderclock] - 16;
	if(sprx >= -64 && sprx < 240 && spry >= -32 && spry < 160)
	{
		CheckEnemyNear(spider[me].xpos,spider[me].ypos,0);
		if(SmallWalkMove[SmallWalkEnemy] == 0) // normal mover
		{
			spider[me].clock++;
			spider[me].clock %= (SmallWalkFrames[SmallWalkEnemy] * 6);
		}
		if(player_state != player_state_attack)
		{
			if((abs(player.xpos - spider[me].xpos) < 12) && (abs(player.ypos - spider[me].ypos) < 12) && Freeze_Player == 0)
			{
				HitPlayer(1);
			}
		}
		//if(EnemySprite[nxtenemy] != ENEMY_MONKEY)
		LoadEnemyPalette(SmallGPalette[SmallWalkEnemy],nxtenemypal);
	   	Sprite[mysprite].Pltt = 2 + PalCache;

	//	EnemySprite[nxtenemy] = ENEMY_MONKEY;
		sprite_ptr = (u32)SmallGWalkSprite[SmallWalkEnemy] + (spider[me].clock >> 3) * 512;
		LoadEnemySprite(sprite_ptr, 512);
		
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		
		if(spider[me].dx >= 0)
			Sprite[mysprite].HFlip = 0;
		else
			Sprite[mysprite].HFlip = 1;
		
		
			
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
	
	if(FrisbeeHit(spider[me].xpos,spider[me].ypos,32))
	{
					Sample_Play(SMPL_KILL_ENEMY);
		spawn(initbaddyblast,spider[me].xpos,spider[me].ypos,0);
		respawnme();
		remove();
		Sprite[mysprite].VPos = 161;
	}

	
	
}

