// main.h (about time!)

#ifndef _MAIN_H
#define _MAIN_H

#define VERSION_EUROPE 1



#include <AGB.h>
#include "asldefines.h"

#include "spritelist.h"

#define MAP_AREA_WIDTH	512
#define MAP_AREA_HEIGHT	64
#define EEPROM_KBIT_SIZE    4   //  When 4Kbit EEPROM is used, set "4" here, 



typedef void (*IntrFuncp)(void); //< Interupt table function pointer

Funcp GameStateLoop;
//Funcp HBlankRoutine;				// current function to call each HBlank (game, menu, fadein etc.)
Funcp VBlankRoutine;				// current function to call each VBlank
Funcp HBlankFast;

u16	*	WorkMap;
u16 *   FrontMap;
u16 *   BossMap;
u8 MapActive; 
u16 PlayerMapWidth;
u16 PlayerMapHeight;
s8 fadeval;
s16 torchcentre;           // torch effect left/right values
u8 TorchLit;				// set when torch is lit
u8 torchtop,torchbottom;			// torch effect top/bottom values
s16 last_map_x,last_map_y;			// last tile position of game area

const u32 EnemySprite[6];
const u32 EnemySpriteOffset[6];
const u32 EnemyPaletteOffset[8];
u32 LastEnemySprite[6];
u32 LastEnemyPalette[6];
u8 EnemySpriteUsed[6];
u8 EnemyPalUsed[6];

const s8 bobtable[32];
const s16 wobble[16];
const u16 MenuShadowPalette[16];
const u32 OamData_Sample[1][2];

const u8 MapSpotx[11][6];
const u16 MapSpoty[11][6];
const u8 LevelEndProper[22];
const u16 Lightning[16];

void (*IntrTable[13])();  // Interrupt table

u8 OutOfSpritesWarn;			// gets set when game runs out of sprites

u8 NextSprite,LastSprite;
u8 enemy_sprite;				// stores id of last visible enemy
s16 Boss_xpos,Boss_ypos;      // Boss co-ordinates
u8 Boss_armrot;
u8 Boss_armlift;
u16 GameClock; // 0-255 game frame counter
s16 restart_xpos,restart_ypos;
u8 fadeto;						// set this 0-15 to automatically fade to that level
u8 fadetolevel;					// current fade value
u8 NextLevel;					// flag to call for next level to be loaded
u8 Level_Map;					// current map type (0 - 5)
u8 Game_Area;		// what area (le-wahi,ta-wahi etc.)


u16 daytime; 
u16 GoingToSleep;				// set to 1 to trigger start of sleep mode countdown
u8 itsraining;
u8 Game_Level;
u8 Game_Character;				// what character the player has selected
u8 Game_Difficulty;
s16 WaterLevel;				// y position of top of water
u8 ForegroundMode;			// mode for screen 1 (0 = solid, 1 = alpha, 2 = water, 3 = Off)
u8 spotcount;
u8 LevelTextNum; // string number to display at start of level
u8 nxtenemy;
u8 MaxEnemies;
u8 nxtenemypal; 				// next enemy palette slot to use
u8 MaxEnemyPals;				// maximum enemy palettes
u8 SpriteCache; // what sprite buffer to use
u8 PalCache;	// what palette buffer to use

s8 lastcamera; // last camera triggered
u8 rotateclock;
u8 rotateclock2;
u8 CharAvail[6]; // is character available
u8 NCharAvail[6]; // temp version to be copied into CharAvail before saving
u8 Music_Volume,SFX_Volume;
u8 Game_Controls;
u8 Game_Slot;

u8 BaragTwin;
u8 Lingo; // Current language being used

s16 lightningtime;

u16 * Rainbow; // Background Rainbow pointer
u16 * Current_StratList;
s16 Strat_Number;
u8 respawnlist[128];
u8 numrespawns;
u16  PauseScreenState;
u8 GainCharacterSequence; // 0-3 = mask piece, 4 = weld, 5 = 'name' gained , 6 = done

const u32 Particle1[6];
const u32 Particle2[6];
const u32 ParticleP[6];


void IntrDummy(void); 
void HBlankIntr(void);
void VBlankIntr(void);
void HandleFadeTo(void);
void HBlankRoutine(Funcp hblank);

void GameLoop(void);
void GameOverLoop(void);
void FadeInLoop(void);
void MosaicInLoop(void);
void MosaicOutLoop(void);
void LevelEndLoop(void);
void LevelTextLoop(void);
void GainCharacterLoop(void);

void HBlankLoader(void); // clean screen for loading
void HBlankGame(void);
void HBlankGameRain(void);
void HBlankGameSnow(void);
void HBlankGameTorch(void);
void HBlankGameWater(void);
void HBlankPause(void);
void HBlankMemcard(void);
void HBlankGainChar(void);
void HBlankMenu(void);
void HBlankLingoMenu(void); // H Blank routine for menus
void HBlankGameOver(void); // H Blank routine for Game OVer
void HBlankGameHaze(void); // H blank routine for in-game heat haze
void HBlankGameHeat(void); // H blank routine for in-game heat haze
void VBlankGame(void);
void VBlankGameTorch(void);
void VBlankMenu(void); // vblank routine for menus
void VBlankLightning(void);
void VBlankBoss(void);

void PauseExitLoop(void);
void PauseLoop(void);
void GameSetup(void);
void SoundPlay(void);
void ArgoVBlank2(void);

void StoreHVBlank(void);
void RestoreHVBlank(void);


#endif
