// Map routines


#include <AGB.h>
#include "main.h"

void ClearMap(void)
{
	u16 x,y;
	u8 a;
	a = WorkMap[17 * MAP_AREA_WIDTH];
	for(y = 0; y < 64; y++)
		for(x = 0 ; x < 64; x++)
			WorkMap[x + y * MAP_AREA_WIDTH] = 0;
}

void ClearMapArea(u16 width,u16 height)
{
	u16 x,y;
	u16 a;
	
	a = WorkMap[20 * MAP_AREA_WIDTH];
	for(y = 0 ; y < height;y++)
		for(x = 0 ; x < width; x++)
			WorkMap[x + y * MAP_AREA_WIDTH] = a;
}

void LoadMap(u16 * map,u16 width,u16 height) // normal copy load of map 
{
	u32 x,y;
	MapActive = 0;	
	
	for(y = 0; y < height ; y++)
	{
		DmaCopy(3,map + (width * y),(u32)(WorkMap + (y << 10)), width * 2,32);
		DmaWait(3);
//		for(x = 0; x < width; x++)
//		{
//			WorkMap[x + (y << 9)] = *(map + x + (width * y));
//		}
	}
	MapActive = 1;
}

void LoadBossMap(u16 *map,u16 width,u16 height) // copy boss background (body) to boss map area
{
	u16 x,y;
	u32 dest;
	
	dest = BG_VRAM + 1 * 2048;

	MapActive = 0;
	for(y = 0; y < height; y++)
	{
		DmaCopy(3,map + (width * y),(u32)(dest + (y * 64)),width * 2,32);
		DmaWait(3);
	}
	MapActive = 1;
}

void LoadBossMapFlip(u16 *map,u16 width,u16 height) // copy boss background (body) to boss map area
{
	u16 x,y;
	u32 dest;
	u16 * ptr;
	
	dest = BG_VRAM + 1 * 2048;
	ptr = (u16 *)dest;
	
	MapActive = 0;
	for(y = 0; y < height; y++)
		for(x = 0; x < width; x++)
			ptr[x + y * 32] = map[width - x - 1 + y * width] | 1024; 
	
	MapActive = 1;
}


void LoadBossMap2(u16 *map,u16 width,u16 height) // copy boss background (body) to boss map area
{
	u16 x,y;
	u32 dest;
	
	dest = BG_VRAM + 5 * 2048;

	MapActive = 0;
	for(y = 0; y < height; y++)
	{
		for(x = 0; x < width; x++)
		{
			*(u16 *)(dest + (y * 64) + x * 2) = *(u16 *)(map + (width * y + x)) + 130;
		}
		//DmaCopy(3,map + (width * y),(u32)(dest + (y * 64)),width * 2,32);
		//DmaWait(3);
	}
	MapActive = 1;
}

void LoadOffsetMap(u16 * map,u16 width, u16 height, u16 tileoffset,u16 targetwidth,u16 targoffx,u8 targoffy,u16 sourceoffx,u8 sourceoffy, u16 sourcewidth)
{
	u32 x,y;
	MapActive = 0;
	for(y = 0 ; y < height ; y++)
	{
		for(x = 0; x < width; x++)
		{
			WorkMap[(x + targoffx) + ((y + targoffy) * targetwidth)] = (*(map + x + sourceoffx + (sourcewidth * (y + sourceoffy)))) + tileoffset;
		}
	}
	MapActive = 1;
}

void LoadOffsetFarMap(u16 * map,u16 width, u16 height, u16 tileoffset,u32 block,u16 targetwidth,u8 xoff,u8 yoff, u16 actwidth)
{
	u32 x,y;
	u16 * ptr;
	
	ptr = (u16*)BG_VRAM + block;
	MapActive = 0;
	for(y = 0 ; y < height ; y++)
	{
		for(x = 0; x < width; x++)
		{
			*(ptr + x + (y * targetwidth)) = (*(map + x + xoff + (actwidth * (y + yoff)))) + tileoffset;
		}
	}
	MapActive = 1;
}

void LoadCompMap(u16 * map) // load room compressed map
{
	
	DmaArrayClear(3,0,(u32)WorkMap,32);
	while(*map != 0xffff)
	{
		u16 tx,ty,bx,by,x,y;
		
		tx = *map++;
		ty = *map++;
		bx = *map++;
		by = *map++;
		for(y = ty; y < by; y++)
		{
			for(x = tx; x < bx; x++)
			{
				WorkMap[x + y * MAP_AREA_WIDTH] = *map++;
			}
		}
	}
	
}

