/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "mask.h"
#include "main.h"
#include "masksprites.h"
#include "menubutton.h"
#include "Flags.h"


maskparms mask[8];

const u8 masknum[6] = {2,0,3,4,1,5};
const u8 gamemasknum[6] = {2,4,0,1,3,5};
u8 maskbob;
u8 oldmselect;
u8 maskscale;
s8 maskscaled;

void HandleMask(void);
void HandleCodeMask(void);
void HandleFlagSprite(void);

void initmask(void)
{
	u32 i;
	
	mask[0].frame = GrabASprite();
//	mask[0].shadow = GrabASprite();
	Object[num_strats].handle = HandleMask;
	Object[num_strats].remover = 0;
	
	i = mask[0].frame;
      	Sprite[i].CharNo = MASK_MSPRITE + (masknum[menuselect] * 64);
    //   	Sprite[i].Shape = OAM_SQUARE;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 3;
         Sprite[i].Priority = 1;
	    Sprite[i].AffineMode = 1; // off 3; // on and double size
	    Sprite[i].AffineParamNo_L = 0; // use affine 0

#if 0
	    i = mask[0].shadow;
     	Sprite[i].CharNo = MASK_MSPRITE + (masknum[menuselect] * 64);
    //   	Sprite[i].Shape = OAM_SQUARE;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 4;
         Sprite[i].Priority = 2;
 	    Sprite[i].AffineMode = 1; // off 3; // on and double size
	    Sprite[i].AffineParamNo_L = 0; // use affine 0
#endif
       mask[0].xpos = parm_xpos;
        mask[0].ypos = parm_ypos;
 	LoadPalette((u32)MaskPalette[masknum[menuselect]],3);
 	LoadSprite((u32)Mask1Sprite,MASK_MSPRITE_OFFSET,MASK_MSPRITE_SIZE * 6);
 	LoadPalette((u32)MenuShadowPalette,4);
	maskbob = 0;
	oldmselect = 99;
	maskscale = 1;
	maskscaled = 1;
}

void HandleMask(void)
{
	s16 sprx,spry;
	mysprite = mask[0].frame;
	sprx = mask[0].xpos + bobtable[maskbob / 2];
	spry = mask[0].ypos + bobtable[maskbob / 2];
	maskbob++;
	if(maskbob == 64)
		maskbob = 0;
	Sprite[mysprite].CharNo = MASK_MSPRITE + (masknum[menuselect] * 64);
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;
#if 0
	mysprite = mask[0].shadow;
	Sprite[mysprite].CharNo = MASK_MSPRITE + (masknum[menuselect] * 64);

	sprx = mask[0].xpos + 4;
	spry = mask[0].ypos + 4;
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;
#endif	
	
	if(menuselect != oldmselect)
		LoadPalette((u32)MaskPalette[masknum[menuselect]],3);
 	
 	*(vu16 *)(OBJ_PLTT + 96 + 4) = PlayerEyePalette[(GameClock >> 4) % 5];
 	SpriteScaleFine(0,maskscale * 2,maskscale * 2);
 	if((GameClock & 3) == 0)
 	{
 		maskscale+= maskscaled;
 	}
 	if(maskscale <= 24)
 		maskscaled = 1;
 	if(maskscale >= 32)
		maskscaled = -1;
}

void initcodemask(void)
{
	u32 i;
	u8 digit,masknum;
	masknum = Object[num_strats].parameter & 7;
	digit = Object[num_strats].parameter & 7;
	mask[digit].frame = GrabASprite();
	//mask[digit].shadow = GrabASprite();
	Object[num_strats].handle = HandleCodeMask;
	Object[num_strats].remover = 0;
	
	i = mask[digit].frame;
      	Sprite[i].CharNo = MASK_MSPRITE + (masknum * 64);
    //   	Sprite[i].Shape = OAM_SQUARE;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 3;
         Sprite[i].Priority = 1;
	    Sprite[i].AffineMode = 1; // off 3; // on and double size
	    Sprite[i].AffineParamNo_L = 0; // use affine 0
        mask[digit].xpos = parm_xpos;
        mask[digit].ypos = parm_ypos;
 	
 	LoadPalette((u32)MaskPalette,3);
 	LoadSprite((u32)Mask1Sprite,MASK_MSPRITE_OFFSET,MASK_MSPRITE_SIZE * 6);
 	LoadPalette((u32)MenuShadowPalette,11);
	maskbob = 0;
	maskscale = 1;
	maskscaled = 1;
	SpriteScaleFine(1,8,8);
}

void HandleCodeMask(void)
{
	s16 sprx,spry;
	u8 digit,masknum;
	
	digit = Object[current_strat].parameter & 7;
	masknum =0; // codedigit[digit];
 	LoadPalette((u32)MaskPalette,3);
	
	mysprite = mask[digit].frame;
	sprx = mask[digit].xpos + bobtable[maskbob / 2] - 32;
	spry = mask[digit].ypos + bobtable[maskbob / 2] - 32;
	
	if(digit == 0)
	{
		maskbob++;
		if(maskbob == 64)
			maskbob = 0;
	}
	
	Sprite[mysprite].CharNo = MASK_MSPRITE + (masknum * 64);
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;
	//mysprite = mask[digit].shadow;
	///Sprite[mysprite].CharNo = MASK_MSPRITE + (masknum * 64);
	//sprx = mask[digit].xpos - 28;
	//spry = mask[digit].ypos - 28;
	//Sprite[mysprite].HPos = sprx & 511;
	//Sprite[mysprite].VPos = (spry + 256) & 255;

	
	if( maskscale < 16)
	{
		SpriteScaleFine(0,maskscale / 2 ,maskscale / 2);
	}
	else
	{
		sprx = maskscale;

		if(menuselect == digit)
		{
			sprx += 4;
	  //  	Sprite[mysprite].AffineParamNo_L = 0; // the scaling one
	 		SpriteScaleFine(0,sprx / 2,sprx / 2);
			mysprite = mask[digit].frame;
	    	Sprite[mysprite].AffineParamNo_L = 0; // the scaling one
	 	}
	 	else
	 	{
	 	//    Sprite[mysprite].AffineParamNo_L = 1; // non scaled affine
			mysprite = mask[digit].frame;
		    Sprite[mysprite].AffineParamNo_L = 1; // non scaled affine

	 	}
 	}
 	
 	if((GameClock & 3) == 0)
 	{
 		maskscale+= maskscaled;
 	}
 	if(maskscale < 16)
 		maskscaled = 1;
 	if(maskscale >= 16)
		maskscaled = 0;
}

void initeolmask(void)
{
	u32 i;
	u8 digit,masknum;
	masknum = Object[num_strats].parameter & 7;
	digit = Object[num_strats].parameter >> 3;
	mask[digit].frame = GrabASprite();
	mask[digit].shadow = GrabASprite();
	Object[num_strats].handle = HandleEolMask;
	Object[num_strats].remover = 0;
	
	i = mask[digit].frame;
      	Sprite[i].CharNo = ENEMY_SPRITE + (masknum * 64);
    //   	Sprite[i].Shape = OAM_SQUARE;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 2;
         Sprite[i].Priority = 0;
	    Sprite[i].AffineMode = 1; // off 3; // on and double size
	    Sprite[i].AffineParamNo_L = 0; // use affine 0
	    i = mask[digit].shadow;
     	Sprite[i].CharNo = ENEMY_SPRITE + (masknum * 64);
    //   	Sprite[i].Shape = OAM_SQUARE;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 10;
         Sprite[i].Priority = 1;
        mask[digit].xpos = parm_xpos;
        mask[digit].ypos = parm_ypos;
	    Sprite[i].AffineMode = 1; // off 3; // on and double size
	    Sprite[i].AffineParamNo_L = 0; // use affine 0
 	
 	LoadPalette((u32)MaskPalette,2);
 	LoadSprite((u32)Mask1Sprite,ENEMY_SPRITE_OFFSET,MASK_MSPRITE_SIZE * 6);
 	LoadPalette((u32)MenuShadowPalette,10);
	maskbob = 0;
	maskscale = 1;
	maskscaled = 1;
	SpriteScaleFine(1,16,16);
}

void HandleEolMask(void)
{
	s16 sprx,spry;
	u8 digit,masknum;
	
	digit = Object[current_strat].parameter >> 3;
	masknum = 0; //codedigit[digit];
 	LoadPalette((u32)MaskPalette,2);
	
	mysprite = mask[digit].frame;
	sprx = mask[digit].xpos + bobtable[maskbob / 2] - 32;
	spry = mask[digit].ypos + bobtable[maskbob / 2] - 32;
	
	if(digit == 0)
	{
		maskbob++;
		if(maskbob == 64)
			maskbob = 0;
	}
	
	Sprite[mysprite].CharNo = ENEMY_SPRITE + (masknum * 64);
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;
	mysprite = mask[digit].shadow;
	Sprite[mysprite].CharNo = ENEMY_SPRITE + (masknum * 64);
	sprx = mask[digit].xpos - 28;
	spry = mask[digit].ypos - 28;
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;

	
	if( maskscale < 16)
	{
		SpriteScaleFine(0,maskscale,maskscale);
	}
	else
	{
		sprx = maskscale;

		if(menuselect == digit)
		{
			sprx += 4;
	    	Sprite[mysprite].AffineParamNo_L = 0; // the scaling one
	 		SpriteScaleFine(0,sprx,sprx);
			mysprite = mask[digit].frame;
	    	Sprite[mysprite].AffineParamNo_L = 0; // the scaling one
	 	}
	 	else
	 	{
	 	    Sprite[mysprite].AffineParamNo_L = 1; // non scaled affine
			mysprite = mask[digit].frame;
		    Sprite[mysprite].AffineParamNo_L = 1; // non scaled affine

	 	}
 	}
 	
 	if((GameClock & 3) == 0)
 	{
 		maskscale+= maskscaled;
 	}
 	if(maskscale < 16)
 		maskscaled = 1;
 	if(maskscale >= 16)
		maskscaled = 0;
}

void initflagsprite(void)
{
	u32 i;
	
	mask[0].frame = GrabASprite();
	Object[num_strats].handle = HandleFlagSprite;
	Object[num_strats].remover = 0;
	
	i = mask[0].frame;
      	Sprite[i].CharNo = MASK_MSPRITE;
   		Sprite[i].Size = FlagEnglishSizeShape[0]; //OAM_SIZE_64x64;
   		Sprite[i].Shape = FlagEnglishSizeShape[1];
   		Sprite[i].Pltt = 3;
         Sprite[i].Priority = 1;
	    Sprite[i].AffineMode = 0; // off 3; // on and double size
	    Sprite[i].AffineParamNo_L = 0; // use affine 0

	      mask[0].xpos = parm_xpos;
        mask[0].ypos = parm_ypos;
 	LoadPalette((u32)FlagPalette[menuselect],3);
 	LoadSprite((u32)FlagSprite[menuselect],MASK_MSPRITE_OFFSET,256);
	oldmselect = 99;
}

void HandleFlagSprite(void)
{
	
	u8 a;
	s16 sprx,spry;
	mysprite = mask[0].frame;
	sprx = mask[0].xpos;
	spry = mask[0].ypos;
	Sprite[mysprite].CharNo = MASK_MSPRITE;
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;

	if(menuselect != oldmselect)
	{
		a = menuselect;
#if VERSION_EUROPE
#else
	if(a == 0) // swap union jack for stars and stripes in US version
		a = 8;
#endif
		LoadPalette((u32)FlagPalette[a],3);
	  	LoadSprite((u32)FlagSprite[a],MASK_MSPRITE_OFFSET,256);
		oldmselect = menuselect;
	}
	
 }

