/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
#include "menubutton.h"
#include "button.h"
#include "main.h"
#include "MenuButtons.h"
#include "strings.h"
#include "text.h"

extern u8 MenuSaveSelect;
extern u8 MenuSaveSelect2;

void HandleButton(void);
u8  menuselect;
u16 MenuBase;

u8 cycleclock;
u8 ButtonWipeoff;
u8 ButtonReady;



const char * const ButtonText[8][82] = {(char *)MMAIN1,(char *)MMAIN2,(char *)MMAIN3,
								(char *)MCHAR1,(char *)MCHAR2,(char *)MCHAR3,(char *)MCHAR4,(char *)MCHAR5,(char *)MCHAR6, // 8
								(char *)MOPT1,(char *)MOPT2,(char *)MOPT3,(char *)MOPT4,(char *)MOPT5,(char *)MOPT6,(char *)MOPT7,(char *)MOPT8, // 16
								(char *)MRESUME1,(char *)MRESUME2,  // 18
								(char *)LCOMPLETE1,(char *)LCOMPLETE2, // 20
								(char *)MLEWAHI,(char *)MBOSS1,(char *)MTAWAHI,(char *)MKOWAHI,(char *)MPOWAHI,(char *)MBOSS2,(char *)MGAWAHI,(char *)MONUWAHI,(char *)MBOSS3,(char *)MENDTRO,  // 30
								(char *)MISSION1,(char *)MISSION2,(char *)MISSION3,(char *)MISSION4,(char *)MISSION5,(char *)MISSION6,(char *)MISSION7,  // 37
								(char *)MISSION8,(char *)MISSION9,(char *)MISSION10, // 40
								(char *)MCONTROL1,(char *)MCONTROL2, // 42
								(char *)MLANG1,(char *)MLANG2,(char *)MLANG3,(char *)MLANG4,(char *)MLANG5,(char *)MLANG6,(char *)MLANG7,(char *)MLANG8,(char *)MLANG9, // 51
								(char *)MCHAR0, // 52
								(char *)MEMCARD1,(char *)MEMCARD2, // 54
								(char *)MYES,(char *)MNO,(char *)MOVERWRITE, // 57
								(char *)MISSION12,(char *)MISSION22,(char *)MISSION32,(char *)MISSION42,(char *)MISSION52,(char *)MISSION62,(char *)MISSION72, // 64
								(char *)MISSION82,(char *)MISSION92,(char *)MISSION102, // 67
								(char *)PAUSE3, // 68
								(char *)MEMCARD3,(char *)MEMCARD4,(char *)MEMCARD5, // 71
								(char *)MSELGAME,(char *)MWIPE, // 73
								(char *)PAUSE1, (char *)PAUSE2, (char *)PAUSE5, //76
								(char *)GAMEOVER,(char *)MCHARUNLOCK, // 78
								(char *)MOFF,(char *)MEMCARD6, // 80
								(char *)PAUSE4, // 81
								
								
								(char *)MMAIN1b,(char *)MMAIN2b,(char *)MMAIN3b,
								(char *)MCHAR1b,(char *)MCHAR2b,(char *)MCHAR3b,(char *)MCHAR4b,(char *)MCHAR5b,(char *)MCHAR6b,
								(char *)MOPT1b,(char *)MOPT2b,(char *)MOPT3b,(char *)MOPT4b,(char *)MOPT5b,(char *)MOPT6b,(char *)MOPT7b,(char *)MOPT8b,
								(char *)MRESUME1b,(char *)MRESUME2b,
								(char *)LCOMPLETE1b,(char *)LCOMPLETE2b,
								(char *)MLEWAHIb,(char *)MBOSS1b,(char *)MTAWAHIb,(char *)MKOWAHIb,(char *)MPOWAHIb,(char *)MBOSS2b,(char *)MGAWAHIb,(char *)MONUWAHIb,(char *)MBOSS3b,(char *)MENDTROb,
								(char *)MISSION1b,(char *)MISSION2b,(char *)MISSION3b,(char *)MISSION4b,(char *)MISSION5b,(char *)MISSION6b,(char *)MISSION7b,
								(char *)MISSION8b,(char *)MISSION9b,(char *)MISSION10b,
								(char *)MCONTROL1b,(char *)MCONTROL2b,
								(char *)MLANG1b,(char *)MLANG2b,(char *)MLANG3b,(char *)MLANG4b,(char *)MLANG5b,(char *)MLANG6b,(char *)MLANG7b,(char *)MLANG8b,(char *)MLANG9b,
								(char *)MCHAR0b,
								(char *)MEMCARD1b,(char *)MEMCARD2b,
								(char *)MYESb,(char *)MNOb,(char *)MOVERWRITEb,
								(char *)MISSION12b,(char *)MISSION22b,(char *)MISSION32b,(char *)MISSION42b,(char *)MISSION52b,(char *)MISSION62b,(char *)MISSION72b,
								(char *)MISSION82b,(char *)MISSION92b,(char *)MISSION102b,
								(char *)PAUSE3b,
								(char *)MEMCARD3b,(char *)MEMCARD4b,(char *)MEMCARD5b,
								(char *)MSELGAMEb,(char *)MWIPEb,
								(char *)PAUSE1b, (char *)PAUSE2b, (char *)PAUSE5b, // 76
								(char *)GAMEOVERb,(char *)MCHARUNLOCKb,
								(char *)MOFFb,(char *)MEMCARD6b, // 80
								(char *)PAUSE4b, // 81
								
								(char *)MMAIN1c,(char *)MMAIN2c,(char *)MMAIN3c,
								(char *)MCHAR1c,(char *)MCHAR2c,(char *)MCHAR3c,(char *)MCHAR4c,(char *)MCHAR5c,(char *)MCHAR6c,
								(char *)MOPT1c,(char *)MOPT2c,(char *)MOPT3c,(char *)MOPT4c,(char *)MOPT5c,(char *)MOPT6c,(char *)MOPT7c,(char *)MOPT8c,
								(char *)MRESUME1c,(char *)MRESUME2c,
								(char *)LCOMPLETE1c,(char *)LCOMPLETE2c,
								(char *)MLEWAHIc,(char *)MBOSS1c,(char *)MTAWAHIc,(char *)MKOWAHIc,(char *)MPOWAHIc,(char *)MBOSS2c,(char *)MGAWAHIc,(char *)MONUWAHIc,(char *)MBOSS3c,(char *)MENDTROc,
								(char *)MISSION1c,(char *)MISSION2c,(char *)MISSION3c,(char *)MISSION4c,(char *)MISSION5c,(char *)MISSION6c,(char *)MISSION7c,
								(char *)MISSION8c,(char *)MISSION9c,(char *)MISSION10c,
								(char *)MCONTROL1c,(char *)MCONTROL2c,
								(char *)MLANG1c,(char *)MLANG2c,(char *)MLANG3c,(char *)MLANG4c,(char *)MLANG5c,(char *)MLANG6c,(char *)MLANG7c,(char *)MLANG8c,(char *)MLANG9c,
								(char *)MCHAR0c,
								(char *)MEMCARD1c,(char *)MEMCARD2c,
								(char *)MYESc,(char *)MNOc,(char *)MOVERWRITEc,
								(char *)MISSION12c,(char *)MISSION22c,(char *)MISSION32c,(char *)MISSION42c,(char *)MISSION52c,(char *)MISSION62c,(char *)MISSION72c,
								(char *)MISSION82c,(char *)MISSION92c,(char *)MISSION102c,
								(char *)PAUSE3c,
								(char *)MEMCARD3c,(char *)MEMCARD4c,(char *)MEMCARD5c,
								(char *)MSELGAMEc,(char *)MWIPEc,
								(char *)PAUSE1c, (char *)PAUSE2c, (char *)PAUSE5c, //76
								(char *)GAMEOVERc,(char *)MCHARUNLOCKc,
								(char *)MOFFc,(char *)MEMCARD6c, // 80
								(char *)PAUSE4c, // 81
									
								(char *)MMAIN1d,(char *)MMAIN2d,(char *)MMAIN3d,
								(char *)MCHAR1d,(char *)MCHAR2d,(char *)MCHAR3d,(char *)MCHAR4d,(char *)MCHAR5d,(char *)MCHAR6d,
								(char *)MOPT1d,(char *)MOPT2d,(char *)MOPT3d,(char *)MOPT4d,(char *)MOPT5d,(char *)MOPT6d,(char *)MOPT7d,(char *)MOPT8d,
								(char *)MRESUME1d,(char *)MRESUME2d,
								(char *)LCOMPLETE1d,(char *)LCOMPLETE2d,
								(char *)MLEWAHId,(char *)MBOSS1d,(char *)MTAWAHId,(char *)MKOWAHId,(char *)MPOWAHId,(char *)MBOSS2d,(char *)MGAWAHId,(char *)MONUWAHId,(char *)MBOSS3d,(char *)MENDTROd,
								(char *)MISSION1d,(char *)MISSION2d,(char *)MISSION3d,(char *)MISSION4d,(char *)MISSION5d,(char *)MISSION6d,(char *)MISSION7d,
								(char *)MISSION8d,(char *)MISSION9d,(char *)MISSION10d,
								(char *)MCONTROL1d,(char *)MCONTROL2d,
								(char *)MLANG1d,(char *)MLANG2d,(char *)MLANG3d,(char *)MLANG4d,(char *)MLANG5d,(char *)MLANG6d,(char *)MLANG7d,(char *)MLANG8d,(char *)MLANG9d,
								(char *)MCHAR0d,
								(char *)MEMCARD1d,(char *)MEMCARD2d,
								(char *)MYESd,(char *)MNOd,(char *)MOVERWRITEd,
								(char *)MISSION12d,(char *)MISSION22d,(char *)MISSION32d,(char *)MISSION42d,(char *)MISSION52d,(char *)MISSION62d,(char *)MISSION72d,
								(char *)MISSION82d,(char *)MISSION92d,(char *)MISSION102d,
								(char *)PAUSE3d,
								(char *)MEMCARD3d,(char *)MEMCARD4d,(char *)MEMCARD5d,
								(char *)MSELGAMEd,(char *)MWIPEd,
								(char *)PAUSE1d, (char *)PAUSE2d, (char *)PAUSE5d,  //76
								(char *)GAMEOVERd,(char *)MCHARUNLOCKd,
								(char *)MOFFd,(char *)MEMCARD6d, // 80
								(char *)PAUSE4d, // 81
										
								(char *)MMAIN1e,(char *)MMAIN2e,(char *)MMAIN3e,
								(char *)MCHAR1e,(char *)MCHAR2e,(char *)MCHAR3e,(char *)MCHAR4e,(char *)MCHAR5e,(char *)MCHAR6e,
								(char *)MOPT1e,(char *)MOPT2e,(char *)MOPT3e,(char *)MOPT4e,(char *)MOPT5e,(char *)MOPT6e,(char *)MOPT7e,(char *)MOPT8e,
								(char *)MRESUME1e,(char *)MRESUME2e,
								(char *)LCOMPLETE1e,(char *)LCOMPLETE2e,
								(char *)MLEWAHIe,(char *)MBOSS1e,(char *)MTAWAHIe,(char *)MKOWAHIe,(char *)MPOWAHIe,(char *)MBOSS2e,(char *)MGAWAHIe,(char *)MONUWAHIe,(char *)MBOSS3e,(char *)MENDTROe,
								(char *)MISSION1e,(char *)MISSION2e,(char *)MISSION3e,(char *)MISSION4e,(char *)MISSION5e,(char *)MISSION6e,(char *)MISSION7e,
								(char *)MISSION8e,(char *)MISSION9e,(char *)MISSION10e,
								(char *)MCONTROL1e,(char *)MCONTROL2e,
								(char *)MLANG1e,(char *)MLANG2e,(char *)MLANG3e,(char *)MLANG4e,(char *)MLANG5e,(char *)MLANG6e,(char *)MLANG7e,(char *)MLANG8e,(char *)MLANG9e,
								(char *)MCHAR0e,
								(char *)MEMCARD1e,(char *)MEMCARD2e,
								(char *)MYESe,(char *)MNOe,(char *)MOVERWRITEe,
								(char *)MISSION12e,(char *)MISSION22e,(char *)MISSION32e,(char *)MISSION42e,(char *)MISSION52e,(char *)MISSION62e,(char *)MISSION72e,
								(char *)MISSION82e,(char *)MISSION92e,(char *)MISSION102e,
								(char *)PAUSE3e,
								(char *)MEMCARD3e,(char *)MEMCARD4e,(char *)MEMCARD5e,
								(char *)MSELGAMEe,(char *)MWIPEe,
								(char *)PAUSE1e, (char *)PAUSE2e, (char *)PAUSE5e, //76
								(char *)GAMEOVERe,(char *)MCHARUNLOCKe,
								(char *)MOFFe,(char *)MEMCARD6e, // 80
								(char *)PAUSE4e, // 81
			
								(char *)MMAIN1f,(char *)MMAIN2f,(char *)MMAIN3f,
								(char *)MCHAR1f,(char *)MCHAR2f,(char *)MCHAR3f,(char *)MCHAR4f,(char *)MCHAR5f,(char *)MCHAR6f,
								(char *)MOPT1f,(char *)MOPT2f,(char *)MOPT3f,(char *)MOPT4f,(char *)MOPT5f,(char *)MOPT6f,(char *)MOPT7f,(char *)MOPT8f,
								(char *)MRESUME1f,(char *)MRESUME2f,
								(char *)LCOMPLETE1f,(char *)LCOMPLETE2f,
								(char *)MLEWAHIf,(char *)MBOSS1f,(char *)MTAWAHIf,(char *)MKOWAHIf,(char *)MPOWAHIf,(char *)MBOSS2f,(char *)MGAWAHIf,(char *)MONUWAHIf,(char *)MBOSS3f,(char *)MENDTROf,
								(char *)MISSION1f,(char *)MISSION2f,(char *)MISSION3f,(char *)MISSION4f,(char *)MISSION5f,(char *)MISSION6f,(char *)MISSION7f,
								(char *)MISSION8f,(char *)MISSION9f,(char *)MISSION10f,
								(char *)MCONTROL1f,(char *)MCONTROL2f,
								(char *)MLANG1f,(char *)MLANG2f,(char *)MLANG3f,(char *)MLANG4f,(char *)MLANG5f,(char *)MLANG6f,(char *)MLANG7f,(char *)MLANG8f,(char *)MLANG9f,
								(char *)MCHAR0f,
								(char *)MEMCARD1f,(char *)MEMCARD2f,
								(char *)MYESf,(char *)MNOf,(char *)MOVERWRITEf,
								(char *)MISSION12f,(char *)MISSION22f,(char *)MISSION32f,(char *)MISSION42f,(char *)MISSION52f,(char *)MISSION62f,(char *)MISSION72f,
								(char *)MISSION82f,(char *)MISSION92f,(char *)MISSION102f,
								(char *)PAUSE3f,
								(char *)MEMCARD3f,(char *)MEMCARD4f,(char *)MEMCARD5f,
								(char *)MSELGAMEf,(char *)MWIPEf,
								(char *)PAUSE1f, (char *)PAUSE2f, (char *)PAUSE5f, //76
								(char *)GAMEOVERf,(char *)MCHARUNLOCKf,
								(char *)MOFFf,(char *)MEMCARD6f, // 80
								(char *)PAUSE4f, // 81
				
								
								(char *)MMAIN1g,(char *)MMAIN2g,(char *)MMAIN3g,
								(char *)MCHAR1g,(char *)MCHAR2g,(char *)MCHAR3g,(char *)MCHAR4g,(char *)MCHAR5g,(char *)MCHAR6g,
								(char *)MOPT1g,(char *)MOPT2g,(char *)MOPT3g,(char *)MOPT4g,(char *)MOPT5g,(char *)MOPT6g,(char *)MOPT7g,(char *)MOPT8g,
								(char *)MRESUME1g,(char *)MRESUME2g,
								(char *)LCOMPLETE1g,(char *)LCOMPLETE2g,
								(char *)MLEWAHIg,(char *)MBOSS1g,(char *)MTAWAHIg,(char *)MKOWAHIg,(char *)MPOWAHIg,(char *)MBOSS2g,(char *)MGAWAHIg,(char *)MONUWAHIg,(char *)MBOSS3g,(char *)MENDTROg,
								(char *)MISSION1g,(char *)MISSION2g,(char *)MISSION3g,(char *)MISSION4g,(char *)MISSION5g,(char *)MISSION6g,(char *)MISSION7g,
								(char *)MISSION8g,(char *)MISSION9g,(char *)MISSION10g,
								(char *)MCONTROL1g,(char *)MCONTROL2g,
								(char *)MLANG1g,(char *)MLANG2g,(char *)MLANG3g,(char *)MLANG4g,(char *)MLANG5g,(char *)MLANG6g,(char *)MLANG7g,(char *)MLANG8g,(char *)MLANG9g,
								(char *)MCHAR0g,
								(char *)MEMCARD1g,(char *)MEMCARD2g,
								(char *)MYESg,(char *)MNOg,(char *)MOVERWRITEg,
								(char *)MISSION12g,(char *)MISSION22g,(char *)MISSION32g,(char *)MISSION42g,(char *)MISSION52g,(char *)MISSION62g,(char *)MISSION72g,
								(char *)MISSION82g,(char *)MISSION92g,(char *)MISSION102g,
								(char *)PAUSE3g,
								(char *)MEMCARD3g,(char *)MEMCARD4g,(char *)MEMCARD5g,
								(char *)MSELGAMEg,(char *)MWIPEg,
								(char *)PAUSE1g, (char *)PAUSE2g, (char *)PAUSE5g, //76
								(char *)GAMEOVERg,(char *)MCHARUNLOCKg,
								(char *)MOFFg,(char *)MEMCARD6g, // 80
								(char *)PAUSE4g, // 81
											
								
								(char *)MMAIN1h,(char *)MMAIN2h,(char *)MMAIN3h,
								(char *)MCHAR1h,(char *)MCHAR2h,(char *)MCHAR3h,(char *)MCHAR4h,(char *)MCHAR5h,(char *)MCHAR6h,
								(char *)MOPT1h,(char *)MOPT2h,(char *)MOPT3h,(char *)MOPT4h,(char *)MOPT5h,(char *)MOPT6h,(char *)MOPT7h,(char *)MOPT8h,
								(char *)MRESUME1h,(char *)MRESUME2h,
								(char *)LCOMPLETE1h,(char *)LCOMPLETE2h,
								(char *)MLEWAHIh,(char *)MBOSS1h,(char *)MTAWAHIh,(char *)MKOWAHIh,(char *)MPOWAHIh,(char *)MBOSS2h,(char *)MGAWAHIh,(char *)MONUWAHIh,(char *)MBOSS3h,(char *)MENDTROh,
								(char *)MISSION1h,(char *)MISSION2h,(char *)MISSION3h,(char *)MISSION4h,(char *)MISSION5h,(char *)MISSION6h,(char *)MISSION7h,
								(char *)MISSION8h,(char *)MISSION9h,(char *)MISSION10h,
								(char *)MCONTROL1h,(char *)MCONTROL2h,
								(char *)MLANG1h,(char *)MLANG2h,(char *)MLANG3h,(char *)MLANG4h,(char *)MLANG5h,(char *)MLANG6h,(char *)MLANG7h,(char *)MLANG8h,(char *)MLANG9h,
								(char *)MCHAR0h,
								(char *)MEMCARD1h,(char *)MEMCARD2h,
								(char *)MYESh,(char *)MNOh,(char *)MOVERWRITEh,
								(char *)MISSION12h,(char *)MISSION22h,(char *)MISSION32h,(char *)MISSION42h,(char *)MISSION52h,(char *)MISSION62h,(char *)MISSION72h,
								(char *)MISSION82h,(char *)MISSION92h,(char *)MISSION102h,
								(char *)PAUSE3h,
								(char *)MEMCARD3h,(char *)MEMCARD4h,(char *)MEMCARD5h,
								(char *)MSELGAMEh,(char *)MWIPEh,
								(char *)PAUSE1h, (char *)PAUSE2h, (char *)PAUSE5h,  //76
								(char *)GAMEOVERh,(char *)MCHARUNLOCKh, // 78
								(char *)MOFFh,(char *)MEMCARD6h, // 80
								(char *)PAUSE4h, // 81
											
								
								};
								
								

buttonparms button[8];

u8 NextButton(void)
{
	u8 a;
	for(a = 0; a < 8; a++)
	if(button[a].ypos == 0)
	{
		button[a].ypos = 1;
		return a;
	}
	return 0;
}

void KillButtons(void)
{
	u8 a;
	for(a = 0; a < 8; a++)
		button[a].ypos = 0;
}

void RemoveButton(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	button[me].ypos = 0;
}

void initmenubutton(void)
{
	u8 me;
	u8 myframe;
	me = NextButton();
//	myframe = GrabASprite();
	button[me].frame = myframe;
//	button[me].shadow = GrabASprite();
	Object[num_strats].handle = HandleButton;
	Object[num_strats].remover = RemoveButton;
  // 	Sprite[myframe].CharNo = BUTTON_MSPRITE;
   //	Sprite[myframe].Shape = 0;
   //	Sprite[myframe].Size = 2;
   // Sprite[myframe].Priority = 2;
	button[me].xpos = parm_xpos + 160;
	button[me].ypos = parm_ypos;
   //	Sprite[myframe].Pltt = 0;
  	button[me].targx = parm_xpos;
   	
   	button[me].targy = parm_ypos;
	button[me].label = Object[num_strats].parameter;
//	Sprite[button[me].shadow] = Sprite[myframe];
//	Sprite[button[me].shadow].Pltt = 1;
	Object[num_strats].parameter = me;
//	LoadPalette(MenuBigButtonPalette,0);
//	LoadPalette(MenuShadowPalette,1);
//	LoadPalette(MenuSmallButtonPalette,2);
//	LoadSprite((u32)MenuSmallButtonSprite,BUTTON_MSPRITE_OFFSET,BUTTON_MSPRITE_SIZE);
//	LoadSprite((u32)MenuBigButtonSprite,BIGBUTTON_MSPRITE_OFFSET,BIGBUTTON_MSPRITE_SIZE);
	cycleclock = 0;
	ButtonWipeoff = 0;
	ButtonReady = 0;
}

void initmenubutton2(void)
{
	u8 me;
	me = Object[num_strats - 1].parameter;
	if(MenuSaveSelect)
	{
		u8 string[20];
		u8 a;
		
		string[0] = MenuSaveSelect + '0';
		string[1] = '.';
		
		for(a = 0 ; a < agbstrlen(&ButtonText[Lingo][button[me].label][0]); a++)
		{
			string[2 + a] = ButtonText[Lingo][button[me].label][a];
		}
		string[2 + a] = 200 + MenuSaveSelect2;
		string[3 + a] = 0;
		BigText(me,button[me].xpos + 8,button[me].ypos + 8,string);
		button[me].targx = 120 - BigTextLen(string) / 2;
	}
	else
	{	
		BigText(me,button[me].xpos + 8,button[me].ypos + 8,&ButtonText[Lingo][button[me].label][0]);
		if(TextAutoCentre)
		{
			button[me].targx = 116 - BigTextLen(&ButtonText[Lingo][button[me].label][0]) / 2; 
 		}
 	}

}

void HandleButton(void)
{
	u8 me;
	u8 myframe;
	u8 a;
	s16 sprx,spry;
	
	me = Object[current_strat].parameter;
	myframe = button[me].frame;	
	
	if(ButtonWipeoff > 0)
	{
		sprx = button[me].targx % 3;
		spry = button[me].targy;
		switch(sprx)
		{
			case 0:
				sprx = button[me].targx - 640;
				break;
			case 1:
				sprx = button[me].targx + 320;
				break;
			case 2:
				sprx = button[me].targx;
				if(button[me].targy & 1)
					spry = button[me].targy - 320;
				else
					spry = button[me].targy + 320;
				break;
		}
		button[me].xpos += smin(sprx - button[me].xpos,8);
		button[me].ypos += smin(spry - button[me].ypos,8);
		
	}
	else
	{
		button[me].xpos += smin(button[me].targx - button[me].xpos,8);
		button[me].ypos += smin(button[me].targy - button[me].ypos,8);
		if(button[me].xpos == button[me].targx && button[me].ypos == button[me].targy)
		{
			ButtonReady = 1;
		}
	}
	sprx = button[me].xpos;
	spry = button[me].ypos;
	
	if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160)
	{
		a = 0;
	//	Sprite[myframe].CharNo = BIGBUTTON_MSPRITE;
	//	Sprite[myframe].Pltt = 0;
   		if(menuselect == me)
   		{
   	//		Sprite[myframe].CharNo = BUTTON_MSPRITE;
   	//		Sprite[myframe].Pltt = 2;
   			a = 1;
   			cycleclock++;
   			if(cycleclock >= 4)
   			{
   		//		CycleColour(2,7,7);
   				cycleclock = 0;
   			}
   		}	
   	//	Sprite[myframe].Priority = 1;
	//	Sprite[myframe].HPos = sprx + a;
	//	Sprite[myframe].VPos = spry + a;
   	//	Sprite[myframe].Shape = 0;
  	// 	Sprite[myframe].Size = 2;
 	//	Sprite[myframe].AffineMode = 0;
 		
 	//	myframe = button[me].shadow;

	//	Sprite[myframe].CharNo = BUTTON_MSPRITE;
   	//	Sprite[myframe].Priority = 2;
	//	Sprite[myframe].HPos = sprx + 4;
	//	Sprite[myframe].VPos = spry + 4;
   	//	Sprite[myframe].Shape = 0;
  	// 	Sprite[myframe].Size = 2;
 	//	Sprite[myframe].AffineMode = 0;
  	 	
  	 	
	}
	else
	{
	//	Sprite[myframe].VPos = 160;
	//	Sprite[button[me].shadow].VPos = 160;
	}
 	BigTextMove(me,button[me].xpos + 8,button[me].ypos + 8);
	
}

