/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "particles.h"
#include "vplayer.h"
#include "cplayer.h"
#include "main.h"
#include "Camera.h"
#include "Frisbee.h"
#include "Shadow.h"
#include "main.h"
#include "door.h"
#include "SampleManager.h"

#define SIZE_OF_FRAME	2048
#define SIZE_OF_FRAME_SHIFT	11

#define	FOLLOW_OFFSET	32




const u16 VFlashPalette[16] = { // Player Hit Palette data (all white)
0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,0x7fff,
};

const s8 handoffset[8] = {15,-6,-11,-21,-26,-9,21,21};
const u8 SpecialHandx[8] = {38,20,8,26,14,32,25,36};
const u8 SpecialHandy[8] = {53,47,28,36,32,51,48,55};

s16 player_tile_x;
s16 player_tile_y;
u16 player_obj;  // player object
u16 currsprite;  // current sprite frame
u8 frameclock;   // counter to delay frame changes to one per n frames
playerparms player;  // player parameters
u32 spritesource[2];   // source of sprite graphics for each player
u16 loadtime;		// debug
u16 oldline;		// debug
u16 chasex[16];
u16 chasey[16];
s8 chasejump[16];
u8 chasepoint;
u8 chaserecord;
u8 lastchasepoint;
u32 chasesprite[16];
u8 chaseflip[16];
u8 oldchasepoint;
u32 lastplayersprite,lastsparesprite;
u16 spriteoffset;
u8	WhatPlayer;
u8  spareswap;
u8 JumpClock;
u8 Freeze_Player;
u8 CameraShake;
u8 Player_Hurt;
u8 player_hurt_frame; // overrides sprite with hurt sequence
s16 CameraPush; // Camera 'push' based on player direction
u8 CameraPushOveride; // set when player is being chased etc.
u8 force_jump;		// when set, force player to jump
u8 justattacked; // when set, idle holds attack anim frame
frisbeeparms Frisbee[4];
u8 elem_power_level;

s8 frisbeelaunched;
u8 frisbeecatch;
u8 attackoveride;
u8 prefirefrisbee;
u8 Frisbee_Return;
u8 Frisbee_Power;
u8 Frisbee_Range;
u8 Frisbee_Hit;
u16 Frisbee_Damage;

u8 MagicTrousers;
u8 playersinking;
u8 PickupItems;
u8 view_y_time;
u8 lastfrisbeeframe;

extern u8 Game_Level;
const u32 SpriteBase[2][9] = {
	(u32)VSpecialSprite,(u32)VRunSprite,(u32)VRunSprite,(u32)VJumpSprite,
	(u32)VAttackSprite,(u32)VClimbSprite,(u32)VIdleSprite,(u32)VHitSprite,(u32)VSwimSprite,
  	(u32)CSpecialSprite,(u32)CWalkSprite,(u32)CRunSprite,(u32)CJumpSprite,
  	(u32)CAttackSprite,(u32)CClimbSprite,(u32)CWalkSprite,(u32)CWalkSprite,(u32)CWalkSprite,
	};

const u16 idleframes[8] = {0 << 11,1<< 11,2<< 11,3<< 11,4<< 11,3<< 11,2<< 11,1<< 11};
extern s16 game_x,game_y;
Funcp player_state;


void MovePlayer(void);
void HandlePlayer(void);
void CheckGround(void);
void CheckButtons(void);
void UpdateFrame(u8 MaxFrame);
void HandleFrisbee(void);

void initplayer(void)
{
	u32 ptr;
	u8 a;
		
	//AGBPrintf("Sprites Size = %d\n",BOSS_SPRITE_OFFSET);
	//AGBPrintFlush();
	PickupItems = 0;	
	spareswap = 0;
	currsprite = 0;
	WhatPlayer = 0;
	player.dx = 1;
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_WALK] + (currsprite << SIZE_OF_FRAME_SHIFT);
	LoadSprite(spritesource[PLAYER_ACTUAL],PLAYER_SPRITE_OFFSET, PLAYER_SPRITE_SIZE);
	Object[num_strats].handle = HandlePlayer;
	Object[num_strats].remover = 0;
	player.xpos = parm_xpos;
	
	// temp
//	player.xpos = 300 * 8;
player.ActionFlags &= ACTION_HASOTHER;
player.falltime = 0;
	player.ypos = parm_ypos;
	player.frame = GrabASprite();
	player.spare = GrabASprite();
	player.shadow = GrabASprite();
	player.spareshadow = GrabASprite();
	player_obj = num_strats;
    Sprite[player.frame] = *(OamData *)OamData_Sample;
    Sprite[player.frame].Priority = 2;
    Sprite[player.frame].ObjMode = 0;
    Sprite[player.frame].AffineMode = 0; // off 3; // on and double size
    Sprite[player.frame].AffineParamNo_L = 0; // use affine 0
   
    // set up a dummy affine parameter set
         
    Sprite[player.shadow] = *(OamData *)OamData_Sample;
    Sprite[player.shadow].Priority = 2;
    Sprite[player.shadow].ObjMode =0; // obj transparency mode
    Sprite[player.shadow].Pltt = 0;
    Sprite[player.shadow].Shape = ShadowSizeShape[1];
    Sprite[player.shadow].Size = ShadowSizeShape[0];
    
    Sprite[player.spare] = *(OamData *)OamData_Sample;
    Sprite[player.spare].Priority = 2;
    Sprite[player.spare].ObjMode = 0;
    Sprite[player.spare].Pltt = 1;
	Sprite[player.spare].VPos = 160;
    Sprite[player.spareshadow] = Sprite[player.shadow];
	
	
	player_state = player_state_run;
	player.jumpoffset &= ACTION_HASOTHER;
	player.health = 5;  // 128 = 100% divide out for display
	chasepoint = 0;
	chaserecord = 0;
	for(a = 0 ; a < 16 ; a ++)
	{
		chasex[a] = player.xpos; // initialise the chase sequencer to rogue values
		chasey[a] = player.ypos;
		chasesprite[a] = SpriteBase[1 - WhatPlayer][SPRITE_WALK];
	}
	oldchasepoint = 0;
	Freeze_Player = 0;
	Player_Hurt = 0;
	frisbeelaunched = 0;
	force_jump = 0;
	frisbeecatch = 0;
	justattacked = 0;
	Frisbee_Return = 36;
	prefirefrisbee = 0;
	MagicTrousers = 0;
	player.yposoffset = 0;
}

void HandlePlayer(void)
{
	u32 ptr;
	s16 view_x,view_y;
	u16 line;
	s16 sprx,spry;
	u8 cp,a,cpt;
	
	
	// flash player when hurt
	// switch on sprite window effect
//	*(vu16 *)REG_DISPCNT = *(vu16 *)REG_DISPCNT | DISP_OBJWIN_ON;
//	*(vu16 *)REG_WINOUT = 31 +  (63 << 8);  // all display, fx on.
//	*(vu16 *)REG_WININ = 31 + (31 << 8);
	
//	BlendAlpha(5,8)

 
		
	if(Player_Hurt > 0)
	{
		Player_Hurt--;
		
	}
	
	
	
  	if(Freeze_Player == 0)
  	{
	    oldline = *(vu16*)REG_VCOUNT; 

		player_tile_x = player.xpos >> 3;
		player_tile_y = player.ypos >> 3;

		player_obj = current_strat;
		
		spriteoffset = currsprite << 11;
		
		if(controller_push & pad_L) // swap players
		{
			if(controller & pad_A)
			{
				MagicTrousers = 1;
			}
			else
			{
				MagicTrousers = 0;
			}

		
			Frisbee_Return = 20;
			if(player.ActionFlags & ACTION_HASOTHER)  // has other player been collected yet ?
			{
				WhatPlayer = 1 - WhatPlayer;
				LoadPalette(VSpecialPalette[Game_Character],WhatPlayer);
				LoadPalette(CSpecialPalette,(1 - WhatPlayer));
				lastplayersprite = 0;
				lastsparesprite = 0;
				for(a = 0 ; a < 16;a ++)
				{
					chasesprite[a] = SpriteBase[1 - WhatPlayer][SPRITE_WALK];
				}
			}
		}

		player_state();
		
		
		
		if(player_hurt_frame)
		{
			spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_NOTDIE] + spriteoffset; //VWalkOffsets[currsprite];
			spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_NOTDIE] + spriteoffset;
			UpdateFrame(7);
			if(currsprite == 0 && frameclock == 0)
				player_hurt_frame = 0;
		}
	
		// caught frisbee, overide anim frames
		
		if(frisbeecatch > 0)
		{
			if(WhatPlayer == 0)
				spritesource[PLAYER_ACTUAL] =  SpriteBase[WhatPlayer][SPRITE_ATTACK] + 2048 * (frisbeecatch >> 3); //VJumpOffsets[currsprite];
		//	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_JUMP]  + spriteoffset;
			frisbeecatch--;
		}
		
		
		
		//	SpriteRotateScale(0,playerang,playerang / 16,playerang / 16);
		//	Sprite[player.frame].HFlip = 0;

			
		//	if(player.xpos > 32 && player.xpos < (240 * 8 - 32))
		if(player_state == player_state_jump)
			player.xpos = player.xpos + (player.dx / 12);
		else
			player.xpos = player.xpos + (player.dx / 12); // was 14
		
		if(player.xpos < 32)
			player.xpos = 32;
			
		if(player.xpos > (PlayerMapWidth * 8 - 32))
			player.xpos = PlayerMapWidth * 8 - 32;
	}
	// move screen with player
	
	view_x = player.xpos - 120;
	if(view_x < 0)
		view_x = 0;
	view_y = player.ypos - 100 + player.jumpoffset;

	// adjust view_y up/down with controller (so player can look up/down)
	if(player_state != player_state_swimming)
	{
		a = 80;
	}
	else
	{
		a = 32;
	}
	if((controller & pad_up) && (player_state != player_state_jump) && (CameraShake == 0))
	{
		if(player_state == player_state_climb)
		{
			view_y -= 32;
		}
		else
		{
			view_y_time++;
			if(view_y_time > 45)
			{
				view_y -=32;
				view_y_time = 45;
			}
		}
	}
	if((controller & pad_down) && (player_state != player_state_jump) && (CameraShake == 0))
	{
		if(player_state == player_state_climb)
		{
			view_y += 64;
		}
		else
		{
			view_y_time++;
			if(view_y_time > 45)
			{
				view_y +=64;
				view_y_time = 45;
			}
		}
	}
	
	if(!(controller & (pad_up | pad_down)) || frisbeelaunched || player_state == player_state_swimming) // clear 2 second timer if frisbee flying or controller not pushed
		view_y_time = 0;

	if(Camera.state == 0)
	{
		game_x = view_x;
		// push camera in direction player is pointing, based off player.dx
		



		if(!CameraPushOveride)
		{
			s8 d;
			d = player.dx >> 4;
			if((player_state == player_state_attack && WhatPlayer == 0) || player.dx == 0)
			{
				d = 2;
				if(Sprite[player.frame].HFlip)
					d = -2;
			}
			if(d)
				CameraPush = smin(CameraPush + d,64);
			//else
			//	CameraPush -= smin(CameraPush,1);
			game_x += CameraPush;
		}
	
		if(CameraShake)
		{
			a = CameraShake >> 2;
			if(a > 1)
				a = 1;
			view_y += wobble[CameraShake--];
			game_y = view_y;
		}
		// slide game_y towards view_y
		a = 4;
		if(player_state == player_state_jump)
			a = 8;
		if(view_y > game_y)
			game_y += min(a,view_y - game_y);
		if(view_y < game_y)
			game_y -= min(a,game_y - view_y);
		
		if(ThroughDoor)
			game_y = view_y;
			
		// check for limits
		if(game_y > (PlayerMapHeight * 8 - 160))
		{
			view_y = view_y - game_y + (PlayerMapHeight * 8 - 160);
			game_y = PlayerMapHeight * 8 - 160;
		}
		if(game_y < 0)
			game_y = 0;
	
	
		if(game_x >= (PlayerMapWidth << 3) - 240)
		{
		   	game_x = ((PlayerMapWidth << 3) - 240);
		   	last_map_x = -1;
		}
		if(game_x < 0)
		{
		   	game_x = 0;
		   	last_map_x = -1;
		}

		if(game_y >= (PlayerMapHeight << 3) - 160)
		{
		   	game_y = ((PlayerMapHeight << 3) - 160);
		   	last_map_y = -1;
		}
		if(game_y < 0)
		{
			game_y = 0;
			last_map_y = -1;
		}


	
	
	
	
	}

	if(spritesource[PLAYER_ACTUAL] != lastplayersprite)
	{
		LoadSprite(spritesource[PLAYER_ACTUAL],PLAYER_SPRITE_OFFSET,PLAYER_SPRITE_SIZE);
		
	}
	lastplayersprite = spritesource[PLAYER_ACTUAL];
	
	// only draw shadow if player isn't sinking
	sprx = player.xpos - 16 - game_x;
	spry = collision_underme + 8  - game_y;
	if(platform_underme > player.ypos && platform_underme < collision_underme)
		spry = platform_underme - 24 - game_y;
		
	if(sprx >= -32 && sprx < 272 && spry > -16 && spry < 160 && player.yposoffset == 0)
	{
		Sprite[player.shadow].CharNo = SHADOW_SPRITE; // position shadow at groundpos
		Sprite[player.shadow].HPos = sprx;
		Sprite[player.shadow].VPos = spry;
	}
	else
	{
		Sprite[player.shadow].VPos = 160;
	}



	sprx = player.xpos - 32 - game_x;
	spry = player.ypos - 48 - game_y + player.yposoffset;
	if(player.yposoffset)
	{
		Window1(sprx - 64,spry + 64 - player.yposoffset,sprx + 64,spry + 64,15);
		WindowOut(31 + (31 << 8));
		playersinking = 1;
	}
	else
	{
		if(playersinking)
			WindowOff1();
		playersinking = 0;
	}
	if(sprx >= -32 && sprx < 272 && spry > -48 && spry < 160 && (Player_Hurt & 4) == 0)
	{
		
		Sprite[player.frame].CharNo = PLAYER_SPRITE; //SpriteSeq[currsprite];
		Sprite[player.frame].HPos = sprx;
		Sprite[player.frame].VPos = spry; 
		
		if(player.ActionFlags & ACTION_HASOTHER)
		{
			
			//if(player_state != player_state_idle)
			//{
				cp = (chasepoint + 1) & 15;
			//	lastchasepoint = cp;
			//}
			//else
			//	cp = lastchasepoint;
				
			// check to see if player has moved on from current chase point
			if(chasejump[chasepoint] || (abs(chasex[chaserecord] - chasex[chasepoint]) > FOLLOW_OFFSET || abs(chasey[chaserecord] - chasey[chasepoint]) > FOLLOW_OFFSET))
			{
				cpt = (chasepoint + 1) & 15;
				if(cpt != chaserecord) // don't allow chaser to catch up with player point
					if(abs(chasex[chasepoint] - chasex[cpt]) < 8 && abs(chasey[chasepoint] - chasey[cpt]) < 8)
						chasepoint = cpt;
			}
		//	if(abs(player.xpos - chasex[chaserecord]) > 4 || abs(player.ypos - chasey[chaserecord]) > 4) // record a new point
		//	{
		//	if(player_state != player_state_idle)
			{
				chaserecord = (chaserecord + 1) & 15;
				
				//if(player_state != player_state_idle)
					cp = (chaserecord + 1) & 15;
				
				
				chasex[chaserecord] = player.xpos;
				chasey[chaserecord] = player.ypos + player.yposoffset;
				chasejump[chaserecord] = player.jump;
				chaseflip[chaserecord] = Sprite[player.frame].HFlip;
				chasesprite[chaserecord] = spritesource[PLAYER_SPARE];
			}
		//	if(chasesprite[cp] != lastsparesprite)
			{
				LoadSprite(chasesprite[cp],PLAYER2_SPRITE_OFFSET,PLAYER_SPRITE_SIZE);
			}
			lastsparesprite = chasesprite[cp];
			
				sprx = chasex[cp] - 16 - game_x;
				spry = collision_underme + 8 - game_y;
				if(platform_underme > chasex[cp] && platform_underme < collision_underme)
					spry = platform_underme + 8 - game_y;
					
			if(sprx >= -32 && sprx < 272 && spry > -16 && spry < 160)
			{
				Sprite[player.spareshadow].CharNo = SHADOW_SPRITE; // position shadow at groundpos
				Sprite[player.spareshadow].HPos = sprx;
				Sprite[player.spareshadow].VPos = spry;
			}	
			else
			{
				Sprite[player.spareshadow].VPos = 160;
			}
			
			Sprite[player.spare].HPos = chasex[cp] - 32 - game_x;
			Sprite[player.spare].VPos = chasey[cp] - 48 - game_y;
			Sprite[player.spare].CharNo = PLAYER2_SPRITE; //SpriteSeq[currsprite];
			Sprite[player.spare].HFlip = chaseflip[cp];
			Sprite[player.spare].Pltt = 1;
		}
		else
		{
		//	Sprite[player.spare].VPos = 160; // no 2nd player
			Sprite[player.spareshadow].VPos = 160;
		}
	}
	else
	{
		Sprite[player.frame].VPos = 160;
		if(player.ActionFlags & ACTION_HASOTHER)
		{
			Sprite[player.spare].VPos = 160;
			Sprite[player.spareshadow].VPos = 160;
		}
	}
	// monitor scan lines taken by player routine
	loadtime = *(vu16*)REG_VCOUNT; 
	if(loadtime < oldline)
		loadtime+= 228;
	loadtime -= oldline;
	
	
	if(TorchLit)
	{
		Window0(0,max(4,spry - 16),239,min(159,spry + 64),31);
		*(vu16 *)REG_WINOUT = 63 +  (31 << 8);  // all display, fx on.
		*(vu16 *)REG_WININ = 31 + (31 << 8);
		
		Screen1(1);
		Screen2(1);
		BlendDown(6);
		torchcentre = sprx + 32;
		torchtop = max(0,spry - 20);
		torchbottom = spry + 64;
	}	
	else
	{
		if(torchcentre > 0)
		{
			torchcentre = 0;
			WindowOff0();
		}
	}
	// clear ladder flags and slide flag (momentary flags)
	
	player.ActionFlags &= ~(ACTION_LADDERLEFT | ACTION_LADDERRIGHT | ACTION_SLIDE);
	
}

void UpdateFrame(u8 MaxFrame)
{
   	frameclock++;
	if(frameclock >= 3)
	{
		frameclock = 0;
   		currsprite += 1;
 	}
	
	if(currsprite >= MaxFrame)
	{
		currsprite = 0;
		player_hurt_frame = 0;
	//	Sample_Play(SMPL_MATORAN_SERVO);
	}
	
}

void player_state_swimming(void)
{
    u8 pframe;
    s8 a;
    u8 f;
    
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_SWIM] + spriteoffset; // VWalkOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_SWIM] + spriteoffset;
	UpdateFrame(8);


	a = smin(player.dx,1);
	if(player.dx == 0)
	{
		if(Sprite[player.frame].HFlip == 0)
			a = 1;
		else
			a = -1;
	}	
	if(rndfast(31) == 0)
	{
		spawnparticle(player.xpos + a * 24,player.ypos - 16,0,-1,0,-1,32,0,0);	
		a = rndfast(3);
		switch(a)
		{
			case 0:
				Sample_Play(SMPL_BUBBLES01);
				break;
			case 1:
				Sample_Play(SMPL_BUBBLES02);
				break;
			case 2:
				Sample_Play(SMPL_BUBBLES03);
				break;
			case 3:
				Sample_Play(SMPL_BUBBLES04);
				break;
		}
	}

	a = 2;
	f = 0;
	
	if(controller & pad_up)
	{
		if(collision_aboveme > (player.ypos - 32) && collision_aboveme != 0)
			player.ypos = collision_aboveme + 32;
		else
			if(player.ypos > WaterLevel)
				player.ypos -= 1;
	}	
	if(controller & pad_down)
	{
		if(player.ypos < collision_underme)
			player.ypos += 1;
	}	
    if (controller & pad_left) 
    {
    	Sprite[player.frame].HFlip = 1;
       	if(player.dx > 0)
   			player.dx = 0;
		if(collision_left == 0)
			player.dx = -32;
    	f = 1;
    }
    if ((controller & pad_right))
    {
    	Sprite[player.frame].HFlip = 0;
    	if(player.dx < 0)
   			player.dx = 0;
		if(collision_right == 0)
   			player.dx = 32;
    	f = 1;
    }
    if(f == 0)
    {
   		player.dx = 0;
    }
   	if(player.dx < 0) 
		if(collision_left)
			player.dx = 0;
			
	if(player.dx > 0)
		if(collision_right)
			player.dx = 0;  	

	if( ((controller_push & pad_A) || (force_jump))) // jump
	{
		if((collision_left | collision_right) && (player.ypos < WaterLevel + 16))
		{
			player_state = player_state_jump;
			Sample_Play(SMPL_MATORAN_SERVO);
			player.jump = -12;
			currsprite = 2;
			JumpClock = 32;
			force_jump = 0;
		}
	}


}




// player state handlers

void player_state_walk(void)
{
    u8 pframe;
    
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_WALK] + spriteoffset; // VWalkOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_WALK] + spriteoffset;
	UpdateFrame(8);
    if (controller & PLUS_KEY_MASK)                   // Move OBJ
        MovePlayer();    
	else
	{
		if(player.ActionFlags & ACTION_SLIDE)
		{
			if((GameClock & 3) == 0)
				player.dx -= sgn(player.dx);
		}
		else
		{
			player.dx -= sgn(player.dx);
		}
	}	
	if(player.dx < - 16 || player.dx > 16)
		player_state = player_state_run;
	if(player.dx == 0)
		player_state = player_state_idle;
	
	CheckGround();	
	CheckButtons();


}

void player_state_run(void)
{
 	u8 pframe;
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_RUN] + spriteoffset; //VRunOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_RUN] + spriteoffset;
	UpdateFrame(8);

	if((currsprite & 2) == 0 && frameclock == 0)
		Sample_Play(SMPL_MATORAN_FT);

	if(attackoveride)
	{
		if(attackoveride == 2)
			FireFrisbee(player.xpos,player.ypos - 16,player.dx);
		attackoveride = 1;
		spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_JUMP] + 8192; //VRunOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_RUN] + spriteoffset;
		if(frameclock == 0)
			attackoveride = 0;
	}
   if (controller & PLUS_KEY_MASK)                   // Move OBJ
        MovePlayer();    
	else
		if(player.ActionFlags & ACTION_SLIDE)
		{
		//	if((GameClock & 7) == 0)
			//	player.dx -= sgn(player.dx);
		}
		else
		{
			player.dx /= 2;
		}		

	 if(player.dx == 0)
	 	player_state = player_state_idle;

	if(controller & pad_down)
	{
		player_state = player_state_duck;
		justattacked = 0;
	}


	CheckGround();	
	CheckButtons();
}

void player_state_jump(void)
{
	u8 a;
	spritesource[PLAYER_ACTUAL] =  SpriteBase[WhatPlayer][SPRITE_JUMP] + spriteoffset; //VJumpOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_JUMP]  + spriteoffset;
	
	if(currsprite < 3)
		UpdateFrame(8);
	else
		if(player.jump > 0)
			currsprite = 4;
	MovePlayer();

	if(JumpClock > 0)
	{
		if((MagicTrousers == 0) || ((controller & pad_A) == 0))
		{
			JumpClock--;
		}
		if(controller & pad_A && JumpClock > 16) // keep jumping
		{
			player.jump = -13;
		}
		if(player.jump > -9 && player.jump < 12 && player.dx == 0)
		{
			if(controller_push & pad_A) // double tap for double jump
			{
				if(WhatPlayer == 0) // only for villager
				{
					player.jump = -27;
					JumpClock = 0;
					SpawnParticleLeafSplash(player.xpos,player.ypos,5 + rnd(3)); // let's burst some particles to show the double jump's active

				}
			}
		}
	}
	if(controller_push & pad_B) // attack!
		if(WhatPlayer == 0) // villager only
		{
			player_state = player_state_jump_attack;
			JumpClock = 0;
			currsprite = 0;
			frameclock = 0;
		}
	
	if(collision_aboveme > (player.ypos - 32) && collision_aboveme != 0)
	{
		if(player.jump < 0)
			player.ypos = collision_aboveme + 32;
		player.jump = max(0,player.jump);
		JumpClock = 0;
	}

	player.ypos = max(1,player.ypos + (player.jump >> 2));
	if(player.ypos == 1)
		player.dx = 0;
	// check for falling off map...
	
	if(player.ypos >= ((PlayerMapHeight << 3) + 64))
	{
		player.health = 0; // kill player
		Player_Hurt = 0; // force damage to happen even if player is flashing
		HitPlayer(0);	// and cause  him to be Dyson'ed
		player.falltime = 0;
	}

	if(player.jump >= 0 && player.jump < 4)
		player.jump = 4;
	player.jump+=2;
	a = 24;
	if(WhatPlayer == 0 && (controller & pad_down))
	{
		a = 32; // stomping!
		if(player.jump > 0)
			player.jump++;
	}
	if(player.jump > a)
		player.jump = a;
	
	if(controller_push & pad_A)
	{
		if(player.ypos >= collision_underme - 32)
		{
			force_jump = 2;	
			player.falltime = 0;
		}
	}

	if((player.ActionFlags & ACTION_LADDER) && (controller & (pad_up | pad_down)))
	{
		player_state = player_state_climb;
		currsprite = 0;
		player.jump = 0;
		force_jump = 0;
		player.falltime = 0;
		
	}

	
	if(player.ypos >= collision_underme && player.jump >= 0)
	{
	
		if(player.falltime > 30) // big fall
			HitPlayer(1);
		player.falltime = 0;
		if(a == 32) // shake the camera from a stomp
		{
			CameraShake = 15;
			SpawnParticleLeafSplash(player.xpos,player.ypos,5 + rnd(3));
		}
		player.ypos = collision_underme;
		if(player.dx == 0)
			player_state = player_state_land;
		else
			player_state = player_state_run;
		player.jump = 0;
		//player.jumpoffset = 0;
	}	
	else
	{
		player.jumpoffset = min(64,player.jumpoffset + 2);
	}
	if(player.jump > 0)
		player.falltime++;
}

void player_state_land(void)
{
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_JUMP] + spriteoffset; //VWalkOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_JUMP] + spriteoffset;
	player.ActionFlags &= (ACTION_HASOTHER | ACTION_LADDER); // clear all action flags except for HASOTHER
	JumpClock = 0;
	UpdateFrame(8);
	if(currsprite == 0)
	{
		player_state = player_state_idle;
	}
	if(controller & pad_left)
	{
		if(collision_left == 0)
		{
			player.dx = -32;
			player_state = player_state_run;
		}
	}
	if(controller & pad_right)
	{
		if(collision_right == 0 )
		{
			player.dx = 32;
			player_state = player_state_run;
		}
	}
	
	if(controller & pad_up)
	{
		if(player.ActionFlags & ACTION_LADDER)
			player_state = player_state_climb;
	}
	
	CheckGround();	
	CheckButtons();
}


void player_state_idle(void)
{
	u8 f;
	if(justattacked == 0 || WhatPlayer == 1)
	{
		justattacked = 0;
		spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_IDLE] + idleframes[currsprite]; //VWalkOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_IDLE] + idleframes[currsprite];
	}
	else
	{
		spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_ATTACK]  + 2048 * 4; //VAttackOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_IDLE] ;  // spare idles during attack
		
	}
	player.ActionFlags &= (ACTION_HASOTHER | ACTION_LADDER); // clear all action flags except for HASOTHER and LADDER
	JumpClock = 0;
	if(currsprite != 0 && currsprite != 4 && justattacked == 0)
		UpdateFrame(8);
	else
		if(rnd(400) > 393)
		{
			currsprite++;
			frameclock = 0;
			UpdateFrame(8);
			justattacked = 0;
			Sample_Play(SMPL_MATORAN_SERVO);
		}
		


	// slide left ?
/*
	f = 0;
	if(collision_left > player.ypos)
	{
		if(collision_left < player.ypos + 16)
		{
			player.dx = max(-32,player.dx - 1);
			f = 1;
		}	
	}	
	if(collision_right > player.ypos)
	{
		if(collision_right < player.ypos + 16)
		{	
			player.dx = min(32,player.dx + 1);
			f = 1;
		}	
	}
*/	
	if(f == 0 && player.dx != 0)
	{
		if(player.ActionFlags & ACTION_SLIDE)
		{
			if((GameClock & 3) == 0)
			{
				player.dx -= smin(player.dx,1);
			}
		}
		else
		{
			//player.dx -= smin(player.dx, 2);
		}
	}
	
	if(controller & pad_left)
	{
		if(collision_left == 0)
		{
			player.dx = -32;
			player_state = player_state_run;
			justattacked = 0;
		}
	}
	if(controller & pad_right)
	{
		if(collision_right == 0)
		{
			player.dx = 32;
			player_state = player_state_run;
			justattacked = 0;
		}
	}
	if(controller & pad_up)
	{
		if(player.ActionFlags & ACTION_LADDER)
		{
			player_state = player_state_climb;
			justattacked = 0;
		}
	}
	
	if(controller & pad_down)
	{
		player_state = player_state_duck;
		justattacked = 0;
	}
	CheckGround();	
	CheckButtons();
}

void player_state_duck(void)
{
	u8 f;
	if(justattacked == 0 || WhatPlayer == 1)
	{
		justattacked = 0;
		spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_JUMP] + idleframes[currsprite]; //VWalkOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_JUMP] + idleframes[currsprite];
	}
	else
	{
		spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_ATTACK]  + 2048 * 4; //VAttackOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_JUMP] ;  // spare idles during attack
		
	}
	player.ActionFlags &= (ACTION_HASOTHER | ACTION_LADDER); // clear all action flags except for HASOTHER and LADDER
	player.ActionFlags |= ACTION_DUCKED;
	
	JumpClock = 0;
	currsprite = 2;

	if(f == 0 && player.dx != 0)
	{
		if(player.ActionFlags & ACTION_SLIDE)
		{
			if((GameClock & 3) == 0)
			{
				player.dx -= smin(player.dx,1);
			}
		}
		else
		{
			//player.dx -= smin(player.dx, 2);
		}
	}
	
	if(controller & pad_left)
	{
		if(collision_left == 0)
		{
			player.dx = -32;
			player_state = player_state_run;
			justattacked = 0;
		}
	}
	if(controller & pad_right)
	{
		if(collision_right == 0)
		{
			player.dx = 32;
			player_state = player_state_run;
			justattacked = 0;
		}
	}
	if(controller & pad_up)
	{
		if(player.ActionFlags & ACTION_LADDER)
		{
			player_state = player_state_climb;
			justattacked = 0;
		}
	}
	if(!(controller & pad_down))
	{
		player_state = player_state_idle;
		justattacked = 0;
		
	}
	CheckGround();	
	CheckButtons();
}



void player_state_attack(void) // is active for chiefs
{
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_ATTACK]  + spriteoffset; //VAttackOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_IDLE] ;  // spare idles during attack
	UpdateFrame(5);
	if(currsprite == 0 && frameclock == 1 && frisbeelaunched == 0 && WhatPlayer == 0) // fire a frisbee!
		FireFrisbee(player.xpos,player.ypos - 16,player.dx);
			
					
	if(currsprite == 0 && frameclock == 0)
	{
		player_state = player_state_idle;
		if(WhatPlayer == 1)
		{
			player.ActionFlags |= ACTION_THROWSWITCH;
		}
		else
		{
			justattacked = 1;
		}
	}
	player.dx = 0;
	
	CheckGround();	
}

void player_state_jump_attack(void) // not available for chiefs
{
	u8 a;
	if(currsprite < 7)
	{
		spritesource[PLAYER_ACTUAL] =  SpriteBase[WhatPlayer][SPRITE_ATTACK] + spriteoffset; //VJumpOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_JUMP]  + spriteoffset;
	}
	else
	{
		spritesource[PLAYER_ACTUAL] =  SpriteBase[WhatPlayer][SPRITE_JUMP] + spriteoffset; //VJumpOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_JUMP]  + spriteoffset;
	}
	if(currsprite == 2 && frameclock == 0 && frisbeelaunched == 0 && WhatPlayer == 0) // fire a frisbee!
		FireFrisbee(player.xpos,player.ypos - 16,player.dx);
	if(currsprite < 4)
		UpdateFrame(5);
	else
		player_state = player_state_jump;
	MovePlayer();

	player.ypos = max(1,player.ypos + (player.jump >> 2));
	if(player.ypos == 1)
		player.dx = 0;

	// check for falling off map...
	
	if(player.ypos >= ((PlayerMapHeight << 3) + 64))
	{
		player.health = 0; // kill player
		Player_Hurt = 0; // force damage to happen even if player is flashing
		HitPlayer(0);	// and cause  him to be Dyson'ed
		
	}


	player.jump++;
	a = 32;

	if(player.jump > a)
		player.jump = a;
	
	
	if(player.ypos >= collision_underme && player.jump >= 0)
	{
	
		player.ypos = collision_underme;
		player_state = player_state_run;
		player.jump = 0;
		//player.jumpoffset = 0;
	}	
	else
	{
		player.jumpoffset = min(64,player.jumpoffset + 2);
	}
}
void player_state_special(void)
{
	s16 a,b;
	player.dx = 0;
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_SPECIAL] + spriteoffset; // VSpecialOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_IDLE];  // spare idles during attack
	if(controller & pad_R)
	{
		if(currsprite < 3)
		{
			UpdateFrame(8);
		}
		if(EnoughPower())
			elem_power_level = min(240,elem_power_level + 2);
		else
			elem_power_level = min(59,elem_power_level + 1);
	}
	else
	{
		UpdateFrame(8);
	}
//	BlendAlpha(12,8);
	a = fsin[(GameClock << 3) & 255];
	b = fsin[((GameClock << 3) + 64) & 255];
	spawnparticle(player.xpos + SpecialHandx[currsprite] - 32  - (a >> 4),player.ypos - 64 + SpecialHandy[currsprite] + (b >> 6),a >> 5,b >> 6,0,0,32,4,2);	

	if(currsprite == 0 && frameclock == 1)
	{
			spawn(initflash,player.xpos,player.ypos,0);
			elem_power_level = 0;
	}
	if( currsprite < 5)
	{
		flash_x = player.xpos + SpecialHandx[currsprite] - 32;
		flash_y = player.ypos + SpecialHandy[currsprite] - 64;
	}
	if(currsprite == 5 && frameclock == 0)
	{
		numparticles = 0; // reset particles NOW!
		flash_scale = 5; // trigger start of expanding flash	
		flash_x = player.xpos;
		flash_y = player.ypos;
		SpawnParticleRing(player.xpos,player.ypos,8,2,1);
	//	if(WhatPlayer == 1)
		{
			player.ActionFlags |= ACTION_POWER;
			Sample_Play(SMPL_MATORAN_FIRE);
			if(elem_power_level > 60)
			{
				player.ActionFlags |= ACTION_SMARTBOMB;
				player.elemental_power -= EnoughPower();
			}
		}
	}
	if(currsprite == 0 && frameclock == 0)
	{
		player_state = player_state_idle;
		SpawnParticleRing(player.xpos,player.ypos,8,2,1);
	//	BlendAlpha(5,8);
	}
	CheckGround();	
}

void player_state_climb(void)
{
	u8 f;
	if(player.ActionFlags & ACTION_LADDER)
	{
		player.dx = 0;
		spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_CLIMB]  + spriteoffset; //VClimbOffsets[currsprite];
		spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_CLIMB]  + spriteoffset;
		Sprite[player.frame].HFlip = 0;
		if(player.ActionFlags & ACTION_LADDERLEFT)
			Sprite[player.frame].HFlip = 1;
			
		if(controller & pad_up)
		{
			UpdateFrame(6);
			player.ypos -= 2;
		}
		if(controller & pad_down)
		{
			UpdateFrame(6);
			player.ypos += 2;
			if(player.ypos >= collision_underme)
			{
				player_state = player_state_idle;
			}
		}
		// possibly add jump from ladder
		if((controller_push & pad_A) || (force_jump)  ) // jump
		{
			player_state = player_state_jump;
			Sample_Play(SMPL_MATORAN_SERVO);
			player.jump = -12;
			currsprite = 2;
			JumpClock = 32;
			force_jump = 0;
		}
		// walk off ladder
		if(controller & pad_left)
		{
			if(collision_left == 0)
			{
				player.dx = -32;
				player_state = player_state_run;
				justattacked = 0;
			}
		}
		if(controller & pad_right)
		{
			if(collision_right == 0)
			{
				player.dx = 32;
				player_state = player_state_run;
				justattacked = 0;
			}
		}

		

	}
	else // not on a ladder anymore, so fall..
	{
		player_state = player_state_jump;
		Sample_Play(SMPL_MATORAN_SERVO);
		currsprite = 3;
		player.jump = 0;
		if(controller & pad_up)
		{
			player.jump = -12;
			currsprite = 2;
			JumpClock = 32;
			force_jump = 0;
		}
	}
}

// Lego stuff can't die, so we'll pretend ;)
void player_state_notatalldead(void)
{

	u8 a;
	player.dx = 0;
	spritesource[PLAYER_ACTUAL] = SpriteBase[WhatPlayer][SPRITE_NOTDIE] + spriteoffset; //VWalkOffsets[currsprite];
	spritesource[PLAYER_SPARE] = SpriteBase[1 - WhatPlayer][SPRITE_NOTDIE] + spriteoffset;
	player.ActionFlags &= ACTION_HASOTHER; // clear all action flags except for HASOTHER
	
	
	
	if(currsprite == 0 && frameclock == 0)  // reset position at end of death anim
	{
		if(fadeto != 15)
			fadeto = 15; // start fade out (ends when fadetolevel reaches same as fadeto)
		if(fadetolevel == 15) // fade done
		{
				player.lives= max(0,player.lives - 1);
				player.health = 5;
				player_state = player_state_idle;
				fadeto = 0;
				player.xpos = restart_xpos;
				player.ypos = restart_ypos;
				
				
				// reset the other character too
				for(a = 0; a < 16; a++)
				{
					chasex[a] = player.xpos;
					chasey[a] = player.ypos;
				}
		}
	}
	else
		UpdateFrame(7);
}


// check for collision with ground

void CheckGround(void)
{
	if(player.ypos >= collision_underme - 8) // near enough the ground...
	{
		if(player.ypos < collision_underme)
		{
	//		AGBPrintf("col diff = %d\n",collision_underme - player.ypos);
	//		AGBPrintFlush();
		}
		player.ypos = collision_underme;
		player.jumpoffset = max(0,player.jumpoffset - 4);

	}
	else
	{
		if(player.ActionFlags & ACTION_LADDER)
		{
			player_state = player_state_climb;
			currsprite = 0;
			player.jump = 0;
		}
		else
		{
			player_state = player_state_jump;
			currsprite = 3;
			player.jump = 0;
		}
	}
}

// check buttons for attacks etc...

void CheckButtons(void)
{

	if( ((controller_push & pad_A) || (force_jump)) && player.yposoffset < 16 ) // jump
	{
		player_state = player_state_jump;
		Sample_Play(SMPL_MATORAN_SERVO);
		player.jump = -12;
		currsprite = 2;
		JumpClock = 32;
		force_jump = 0;
		if(player.yposoffset > 4) // reduce jump
		{
			player.jump = -6;
			JumpClock = 4;
		}
	}
	if(controller_push & pad_B || prefirefrisbee == 1) // attack
	{
		
		if(player_state == player_state_run && 	WhatPlayer == 0)
		{
			attackoveride = 2;
			frameclock = 1;
		}
		else
		{
			player_state = player_state_attack;
			currsprite = 0;
			frameclock = 0;
		}
		
	}
	if(controller_push & pad_R) // special
	{
		player_state = player_state_special;
		currsprite = 0;
		frameclock = 0;

	}
}

/*------------------------------------------------------------------*/
/*                      Move OBJ Routine                            */
/*------------------------------------------------------------------*/

void MovePlayer(void)
{

	u8 f;
	u8 a;
	
	a = 2;
	f = 0;
    if (controller & pad_left) 
    {
    	Sprite[player.frame].HFlip = 1;
       	if(player.dx > 0)
  	 	 	if(~(player.ActionFlags & ACTION_SLIDE))
    			player.dx = 0;
		if(collision_left == 0)
		{
			if(player.ActionFlags & ACTION_SLIDE)
				player.dx = max(-48,player.dx - a);
			else
				player.dx = -32;
    	}
    		//if(player.dx > -32)
    		//	player.dx--;
    	
    	f = 1;
    }
    if ((controller & pad_right))
    {
    	Sprite[player.frame].HFlip = 0;
    	if(player.dx < 0)
  	 	 	if(~(player.ActionFlags & ACTION_SLIDE))
     			player.dx = 0;
		if(collision_right == 0)
    		if(player.ActionFlags & ACTION_SLIDE)
    			player.dx = min(48,player.dx + a);
    		else
    			player.dx = 32;
    		//if(player.dx < 32)
    		//	player.dx++;
    	
    	f = 1;
    }
    if(f == 0)
    {
    	if(player.ActionFlags & ACTION_SLIDE)
    	{
    		player.dx -= smin(player.dx,1);
    	}
    	else
    	{
    		player.dx = 0;
    	}
    }
   	if(player.dx < 0) 
		if(collision_left)
			player.dx = 0;
			
	if(player.dx > 0)
		if(collision_right)
			player.dx = 0;
	
#if 0
	// quicksand, slow down player when deep
	if(player.yposoffset > 8) // reduce move
		player.dx = player.dx >> 1;
	if(player.yposoffset > 12) // reduce move more
		player.dx = smin(player.dx,14);
#endif
			

}

void LoadSpriteComp(u32 source, u32 dest,u32 length)
{
	u32 offset;
	
	if(source != 0)
	{
		DmaClear(3,0, dest,length,32);
		offset = (*(u32 *)source) ;
		while(offset != 0xffff)
		{
			source+= 4;
			offset += dest;
			DmaCopy(3,source,offset,32,32);
			source+=32;
			offset = (*(u32 *)source) ;
		}
	}

}

u8 HitPlayer(u8 damage)
{
	
	if(Player_Hurt == 0)
	{
		Sample_Play(SMPL_MATORAN_HURT);

		Player_Hurt = 60;
		player.health = max(0,player.health - damage);
		player_hurt_frame = 1;
		if(player.health <= 0)
			player_state = player_state_notatalldead;
		elem_power_level = 0;
	}	
	return player.health;
}

void FireFrisbee(s16 xpos,s16 ypos,s8 dx)
{
	if(Sprite[player.frame].HFlip == 0)
		dx = 6;
	else
		dx = -6;

	if(frisbeelaunched == 0)
	{
	
		Frisbee_Damage = 1;
		Frisbee_Power = player.elemental_power + 1;
		Frisbee_Range = 48;
		Frisbee_Return = 36;
		if(Frisbee_Power > 0) // extended range
				Frisbee_Return = 20;
		if(Frisbee_Power >= 2) // bouncer
			Frisbee_Range = 96;
		spawn(initfrisbee,xpos,ypos,dx);
		if(Frisbee_Power >= 3) // double disc
			spawn(initfrisbee,xpos,ypos,-dx);
		Sample_Play(SMPL_MATORAN_DISC_WHOOSH);
	}
}

u8 NextFrisbee(void)
{
	u8 a;
	
	for(a = 0; a < 4; a++)
	{
		if(Frisbee[a].range == 0) // available
			return a;
	}
	return 0;
}

void initfrisbee(void)
{
	u8 me;
	
	me = NextFrisbee();

	Object[num_strats].handle = HandleFrisbee;
	Object[num_strats].remover = 0;
	Frisbee[me].frame = GrabASprite();
	Frisbee[me].xpos = parm_xpos;
	Frisbee[me].ypos = parm_ypos;
	Frisbee[me].dy = 0;
	if(controller & pad_up)
		Frisbee[me].dy = -2;
	if(controller & pad_down)
		Frisbee[me].dy = 2;
	Frisbee[me].dx = Object[num_strats].parameter;
	Frisbee[me].range = Frisbee_Range;
	frisbeelaunched++; // flags frisbee return
    Sprite[Frisbee[me].frame] = *(OamData *)OamData_Sample;
	Sprite[Frisbee[me].frame].Size = FrisbeeSizeShape[0];
	Sprite[Frisbee[me].frame].Shape = FrisbeeSizeShape[1];
	Sprite[Frisbee[me].frame].Pltt = 7;
    Sprite[Frisbee[me].frame].Priority = 1;
    Object[num_strats].parameter = me;
    prefirefrisbee = 0;
    LoadPalette(FrisbeePalette,7);
    lastfrisbeeframe = 99;

}

void HandleFrisbee(void)
{
	u8 me;
	
	CycleColour(7,1,6);
	CycleColour(7,11,5);
	
	me = Object[current_strat].parameter;
	if(player_state == player_state_attack && currsprite < 3 && (Frisbee[me].range == 48 || Frisbee[me].range == 96))
	{
		if(Frisbee[me].dx < 0)
			Frisbee[me].xpos = player.xpos - handoffset[currsprite];
		else
			Frisbee[me].xpos = player.xpos + handoffset[currsprite];
		Frisbee[me].ypos = player.ypos - 16;
		Frisbee[me].spin = 0;
		if(Frisbee_Power == 4 && (controller & pad_B)) // full on power up
		{
			currsprite = min(1,currsprite);
			//if(((GameClock + me) & 3) == 0)
			if(Frisbee_Damage > 127)
				Frisbee[me].ypos += srnd(2);
			
			if(me == 0)
				spawnparticle(Frisbee[me].xpos + (fsin[(GameClock << 2) & 255] >> 3),Frisbee[me].ypos + srnd(6),0,0,0,0,8,3,0);
			Frisbee_Damage = min(256,Frisbee_Damage + 1);
			// build up power
		}
	}
	else
	{
		if(Frisbee[me].range < Frisbee_Return)  // adjust for range. lower = longer range
		{
			Frisbee[me].dx = smin(Frisbee[me].dx + smin(player.xpos - Frisbee[me].xpos, 2),8);
			Frisbee[me].dy = smin(Frisbee[me].dy + smin(player.ypos - 16 - Frisbee[me].ypos, 2),8);
		}
		
		if(Frisbee[me].range > Frisbee_Return)
		{
			if(Frisbee_Power >= 2) // return leg for bouncer
			{
				if(Frisbee[me].xpos > game_x + 240)
					Frisbee[me].dx = -6;
				if(Frisbee[me].xpos < game_x)
					Frisbee[me].dx = 6;
				if(Frisbee[me].ypos < game_y)
					Frisbee[me].dy = max(1,abs(Frisbee[me].dy));
				if(Frisbee[me].ypos > game_y + 160)
					Frisbee[me].dy = -max(1,abs(Frisbee[me].dy));
			}
			if(Frisbee[me].range & 1)
			{
				if(controller & pad_up && Frisbee[me].dy > -4)
					Frisbee[me].dy--;
				if(controller & pad_down && Frisbee[me].dy < 4)
					Frisbee[me].dy++;  
			}
		}
		Frisbee[me].xpos += Frisbee[me].dx;
		Frisbee[me].ypos += Frisbee[me].dy;
		Frisbee[me].spin = max(1, 5 - abs(Frisbee[me].dx));
		Frisbee[me].range--;
	}
	if(Frisbee[me].range < Frisbee_Return && abs(Frisbee[me].xpos - player.xpos) < 64)
		if(controller_push & pad_B) // fire another frisbee on return
			prefirefrisbee = 1;
	if((frisbeelaunched == 0) || (Frisbee[me].range <= 0) || (Frisbee[me].range < Frisbee_Return && abs(Frisbee[me].xpos - player.xpos) < 32 && abs(Frisbee[me].ypos - player.ypos) < 32))
	{
		Sprite[Frisbee[me].frame].VPos = 161;
		frisbeecatch = 15;
		Frisbee[me].range = 0;
		frisbeelaunched = max(0,frisbeelaunched - 1);
		Sample_Play(SMPL_MATORAN_DISC_CATCH);
		remove();
	}
	else
	{
		if(Frisbee[me].xpos > game_x - 32 && Frisbee[me].xpos < game_x + 240 && Frisbee[me].ypos > game_y - 8 && Frisbee[me].ypos < game_y + 160)
		{
			Sprite[Frisbee[me].frame].VPos = Frisbee[me].ypos - game_y - 4 + bobtable[Frisbee[me].range & 31];
			Sprite[Frisbee[me].frame].HPos = Frisbee[me].xpos - game_x - 16;
			Sprite[Frisbee[me].frame].CharNo = FRISBEE_SPRITE;
			if(me == 0 && Frisbee[me].spin != lastfrisbeeframe)
			{
				LoadSprite((u32)FrisbeeSprite + Frisbee[me].spin * FRISBEE_SPRITE_SIZE,FRISBEE_SPRITE_OFFSET,FRISBEE_SPRITE_SIZE);
				lastfrisbeeframe = Frisbee[me].spin;
			}
			if(((GameClock + me) & 1) == 0)
				inittrailsprite(Frisbee[me].xpos - 16,Frisbee[me].ypos - 4 + bobtable[Frisbee[me].range & 31],FRISBEE_SPRITE,FrisbeeSizeShape[0],FrisbeeSizeShape[1],7);
			if(Frisbee_Power == 4)
				if(((GameClock + me) & 3) == 0)
					spawnparticle(Frisbee[me].xpos + (fsin[(GameClock << 2) & 255] >> 3),Frisbee[me].ypos + srnd(6),0,0,0,1,16,0,0);

		}
		else
		{
			Sprite[Frisbee[me].frame].VPos = 160;
		}
	}
}


u8 EnoughPower(void)
{
		u8 epok;
	
	
	epok = 0;
	if(WhatPlayer == 1 && player.elemental_power > 0)
		epok = 1;
		
	if(WhatPlayer == 0 && player.elemental_power >= 3)
		epok = 3;
		
	return epok;
}

u8 FrisbeeHit(s16 tx,s16 ty,u8 range)
{

	u8 a;
	if(player.ActionFlags & ACTION_SMARTBOMB) // smartbomb powerup! does 3 points of damage instead of 1
		if(abs(player.xpos - tx) < 240)
			return 3;

	if(frisbeelaunched == 0)
		return 0;
	// replace this with multiple frisbee array if needed
	
	for(a = 0; a < 4; a++)
	{
		if(abs(Frisbee[a].xpos - tx) < range && abs(Frisbee[a].ypos - ty) < range && Frisbee[a].range > 0)
		{
			Frisbee_Hit = a;
			Frisbee[a].range = Frisbee_Return; // come back frisbee
			if(Frisbee_Power == 4) // instant return
				frisbeelaunched = 0; 
			return max(1,(Frisbee_Damage + 64) >> 6); // a hit !
		}
	}
	return 0;	
}