// Screen.c


#include <AGB.h>
#include "asldefines.h"
#include "main.h"
#include "screen.h"
// Menu Screen Setup

// set up screen mode and graphics for Menus

void MenuScreen(void)
{

 *(vu16 *)REG_BG0CNT =                             // Set BG control for BG 0
           BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_2
          | 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

    *(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON | DISP_BG0_ON |  DISP_OBJ_CHAR_1D_MAP; // LCDC ON

	 *(vu16 *)REG_BG2CNT =                             // Set BG control for BG 0
           BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_3
          | 2 << BG_SCREEN_BASE_SHIFT | 2 << BG_CHAR_BASE_SHIFT ;
	Screen2(1);

	*(vu16 *)REG_BLDCNT =  BLD_A_BLEND_MODE | BLD_BG0_1ST | BLD_BG2_2ND;
 
	*(vu16 *)REG_BLDALPHA = (10) + ((14) << 8);
}

void MenuScreenLayer1(void)
{
	 *(vu16 *)REG_BG1CNT =                             // Set BG control for BG 0
           BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_1
          | 1 << BG_SCREEN_BASE_SHIFT | 3 << BG_CHAR_BASE_SHIFT ;
	Screen1(1);
}

void MenuScreen2(void)
{

 *(vu16 *)REG_BG0CNT =                             // Set BG control for BG 0
           BG_COLOR_256 | BG_SCREEN_SIZE_0 | BG_PRIORITY_3
          | 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

    *(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON | DISP_BG0_ON | DISP_OBJ_CHAR_1D_MAP; // LCDC ON

}


// Game Screen Setup

// set up screen mode and graphics for game

void GameScreen(void)
{

	u16 * dest;
	dest = (u16 *)( BG_VRAM + 3 * 2048);
    *(vu16 *)REG_BG0CNT =                             // Set BG control for BG 0 (main game area)
            BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_2
            | 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;
   *(vu16 *)REG_BG1CNT =                             // Set BG control for BG 1 (front layer)
            BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
            | 1 << BG_SCREEN_BASE_SHIFT | 0 << BG_CHAR_BASE_SHIFT ;
    
    *(vu16 *)REG_BG2CNT =                             // Set BG control for BG 2 (far background layer)
            BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_3
            | 2 << BG_SCREEN_BASE_SHIFT | 3 << BG_CHAR_BASE_SHIFT ;
	//*(vu16 *)REG_BG1CNT = 
	//		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
	//		| 4 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT;

    *(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON |  DISP_OBJ_CHAR_1D_MAP; // LCDC ON
	BlendAlpha(5,8);
	DmaClear(3,0,BG_VRAM,6144,32); // clear all to 0 tile
	DmaWait(3);
	DmaClear(3,384 + 26, dest,2048,16);
	DmaWait(3);
	SetMapColour(0,0,0,0);
}

// Front End Screen Setup

// set up screen mode and graphics for front end sequence

void FrontEndScreen(void)
{

   
    *(vu16 *)REG_BG2CNT =                             // Set BG control for BG 2 (far background layer)
            BG_COLOR_256 | BG_SCREEN_SIZE_1 | BG_PRIORITY_3
            | 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

 

    *(vu16 *)REG_DISPCNT = DISP_MODE_1 | DISP_OBJ_ON | DISP_BG2_ON |  DISP_OBJ_CHAR_1D_MAP; // LCDC ON
	BlendAlpha(5,8);

}




void Screen0(u8 onoff)
{
	if(onoff)
		*(vu16 *)REG_DISPCNT |= DISP_BG0_ON;
	else
		*(vu16 *)REG_DISPCNT &= (~DISP_BG0_ON);
}

void Screen1(u8 onoff)
{
	if(onoff)
		*(vu16 *)REG_DISPCNT |= DISP_BG1_ON;
	else
		*(vu16 *)REG_DISPCNT &= (~DISP_BG1_ON);
}
void Screen2(u8 onoff)
{
	if(onoff)
		*(vu16 *)REG_DISPCNT |= DISP_BG2_ON;
	else
		*(vu16 *)REG_DISPCNT &= (~DISP_BG2_ON);
}

void Screen3(u8 onoff)
{
	if(onoff)
		*(vu16 *)REG_DISPCNT |= DISP_BG3_ON;
	else
		*(vu16 *)REG_DISPCNT &= (~DISP_BG3_ON);
}

void Screen1Base(u8 basebank)
{
   
   *(vu16 *)REG_BG1CNT =                             // Set BG control for BG 1 (front layer)
            BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
            | 1 << BG_SCREEN_BASE_SHIFT | basebank << BG_CHAR_BASE_SHIFT ;
    

}


void WipeToBlack(u8 fader)
{
	BlendDown(fader);
}

void WipeToWhite(u8 fader)
{
	BlendUp(fader);
}

void MosaicOut(void)
{
#if 0		
	*(vu16 *)REG_BG0CNT |= BG_MOS_ON;
	*(vu16 *)REG_BG1CNT |= BG_MOS_ON;
	*(vu16 *)REG_BG2CNT |= BG_MOS_ON;
	*(vu16 *)REG_BG3CNT |= BG_MOS_ON;
#endif	
}

void MosaicLevel(u8 a)
{	
#if 0
	*(vu16 *)REG_MOSAIC = (a << 12) + (a << 8) + (a << 4) + a;
#endif
}


void MosaicIn(void)
{
#if 0	
	*(vu16 *)REG_BG0CNT &= (~BG_MOS_ON);
	*(vu16 *)REG_BG1CNT &= (~BG_MOS_ON);
	*(vu16 *)REG_BG2CNT &= (~BG_MOS_ON);
	*(vu16 *)REG_BG3CNT &= (~BG_MOS_ON);
#endif	
}

void Window0(u8 tlx, u8 tly,u8 brx,u8 bry,u8 flags)
{
	*(vu16 *)REG_DISPCNT = *(vu16 *)REG_DISPCNT | DISP_WIN0_ON;
	*(vu16 *)REG_WIN0H = (tlx << 8) + brx;
	*(vu16 *)REG_WIN0V = (tly << 8) + bry;
	*(vu16 *)REG_WININ = (*(vu16 *)REG_WININ & (63 << 8)) | flags;
}

void WindowOff0(void)
{
	*(vu16 *)REG_DISPCNT = (*(vu16 *)REG_DISPCNT & ~DISP_WIN0_ON);
}

void Window1(u8 tlx, u8 tly,u8 brx,u8 bry,u8 flags)
{
	*(vu16 *)REG_DISPCNT = *(vu16 *)REG_DISPCNT | DISP_WIN1_ON;
	*(vu16 *)REG_WIN1H = (tlx << 8) + brx;
	*(vu16 *)REG_WIN1V = (tly << 8) + bry;
	*(vu16 *)REG_WININ = (*(vu16 *)REG_WININ & 63) | (flags << 8);
}

void WindowOff1(void)
{
	*(vu16 *)REG_DISPCNT = (*(vu16 *)REG_DISPCNT & ~DISP_WIN1_ON);
}

void WindowOut(u8 winflags)
{
	*(vu16 *)REG_WINOUT = winflags;

}

void WindowObj(u8 flags)
{
	if(flags == 0)
	{
		*(vu16 *)REG_DISPCNT = (*(vu16 *)REG_DISPCNT & ~DISP_OBJWIN_ON);
	}
	else
	{
		*(vu16 *)REG_DISPCNT |= DISP_OBJWIN_ON;;
		*(vu16 *)REG_WINOUT = (flags << 8) + 31 ;
	}
}

void WindowOutObj(u8 outflags, u8 objflags)
{
	*(vu16 *)REG_DISPCNT |= DISP_OBJWIN_ON;;
	*(vu16 *)REG_WINOUT = outflags + (objflags << 8);

}

void ScreenScale2(s32 scale)
{
	s32 bg2pa,bg2pb,bg2pc,bg2pd;
	s32 start_x,start_y;

	// Set up Scaling Rotation
	// Set up BG Data Reference Direction
	bg2pa = ((s32)fsin[64] * 0x80) / scale;
	bg2pb = 0;
	bg2pc =0;
	bg2pd = ((s32)fsin[64] * 0x80) / scale;

	*(vu16 *)REG_BG2PA = (u16)bg2pa;
	*(vu16 *)REG_BG2PB = (u16)bg2pb;
	*(vu16 *)REG_BG2PC = (u16)bg2pc;
	*(vu16 *)REG_BG2PD = (u16)bg2pd;


	// Set up BG Data Reference Start Point
	start_x = ( 0 * 0x100 )
		- (bg2pa * 120 )
		- (bg2pb * 80 )
		+ (120 * 256);

	start_y = ( 0 * 0x100 )
		- (bg2pc * 120 ) 
		- (bg2pd * 80 ) 
		+ (80 * 256);
	//start_x = 0;
	//start_y = 0;
	// Store result

	*(vu16 *)REG_BG2X_L = (u16)(start_x & 0xffff);
	*(vu16 *)REG_BG2X_H = (u16)(u32)((start_x & 0x0fff0000)>>16);
	*(vu16 *)REG_BG2Y_L = (u16)(start_y & 0xffff);
	*(vu16 *)REG_BG2Y_H = (u16)(u32)((start_y & 0x0fff0000)>>16);


	
}
