/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
#include "player.h"
#include "spikes.h"
#include "main.h"
#include "SampleManager.h"
#include "plop.h"

spikeparms spikes[MAX_SPIKES];

extern s16 game_x;
extern s16 game_y;

u8 plop,plopframe;

s16 plopx,plopy;

void HandleSpike(void);
void HandleSand(void);

u8 NextSpike()
{
	u8 a;
	for(a = 0; a < MAX_SPIKES;a++)
	{
		if(spikes[a].xpos == 0)
		{
			return a;
		}
	}
}

void RemoveSpike(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	spikes[me].xpos = 0;
}

void initspike(void)
{
	u32 i;
	u8 me;
	
	me = NextSpike();
	Object[num_strats].handle = HandleSpike;
	Object[num_strats].remover = RemoveSpike;
    spikes[me].xpos = parm_xpos;
    spikes[me].ypos = wp_ypos;
    spikes[me].xpos2 = wp_xpos;
    spikes[me].ypos2 = parm_ypos;
    Object[num_strats].parameter = me;
}

void HandleSpike(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	
	if(player.xpos > spikes[me].xpos  && player.xpos < spikes[me].xpos2)
	{
		if(player.ypos > spikes[me].ypos && player.ypos < spikes[me].ypos2 )
		{
			if(player.ypos >= collision_underme)
			{
				if(HitPlayer(1))
				{

					player_state = player_state_jump;
					player.jump = -32;
				}
			}
		}
	}

}


void initsand(void)
{
	u32 i;
	u8 me;
	
	me = NextSpike();
	Object[num_strats].handle = HandleSand;
	Object[num_strats].remover = RemoveSpike;
    spikes[me].xpos = parm_xpos;
    spikes[me].ypos = parm_ypos;
    spikes[me].xpos2 = wp_xpos;
    spikes[me].ypos2 = wp_ypos;
 	spikes[me].suckiness = 0;
    Object[current_strat].parameter = me;
}


void HandleSand (void)
{
	u8 me;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;
	
	
	if(player.xpos > spikes[me].xpos && player.xpos < spikes[me].xpos2)
	{
		if(player.ypos >= spikes[me].ypos - 10 && player.ypos < spikes[me].ypos2)
		{
			sprx = player.xpos - game_x - 16;
			spry = player.ypos - game_y + 8;
			if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160)
			{
				plopframe = NextSprite++;
				
				Sprite[plopframe] = *(OamData *)OamData_Sample;
				Sprite[plopframe].Size = PlopSpriteSizeShape[0];
				Sprite[plopframe].Shape = PlopSpriteSizeShape[1];
		   	 	Sprite[plopframe].Priority = 1;
				Sprite[plopframe].HPos = sprx & 511;
				Sprite[plopframe].VPos = (spry + 256) & 255;
				LoadEnemyPalette(PlopSpritePalette,nxtenemypal);
		   		Sprite[plopframe].Pltt = 2 + PalCache;
				sprite_ptr = (u32)PlopSpriteSprite + (rnd(2)) * 64;
				LoadEnemySprite(sprite_ptr, 64);
				Sprite[plopframe].CharNo = EnemySprite[SpriteCache];

				plopframe = NextSprite++;
				
				Sprite[plopframe] = *(OamData *)OamData_Sample;
				Sprite[plopframe].Size = PlopSpriteSizeShape[0];
				Sprite[plopframe].Shape = PlopSpriteSizeShape[1];
		   	 	Sprite[plopframe].Priority = 1;
				Sprite[plopframe].HPos = (sprx + 16) & 511;
				Sprite[plopframe].VPos = (spry + 256) & 255;
		   		Sprite[plopframe].Pltt = 2 + PalCache;
				sprite_ptr = (u32)PlopSpriteSprite + (rnd(2)) * 64;
				LoadEnemySprite(sprite_ptr, 64);
				Sprite[plopframe].CharNo = EnemySprite[SpriteCache];

				
	
			}
	
			// time to suck mightily :)
			if(player.jump >= 0)
				player.yposoffset = spikes[me].suckiness;
			
			if((GameClock & 7) == 0)
				spikes[me].suckiness++;
			
			if(rndfast(31) == 0)
				Sample_Play(SMPL_MATORAN_SINK);	
				
			if(spikes[me].suckiness > 36) // no longer kill player, just slow him down a lot
			{
				spikes[me].suckiness = 36;
			}
			
			//	player.health = 0; // kill player
			//	/Player_Hurt = 0; // force damage to happen even if player is flashing
			//	HitPlayer(0);	// and cause  him to be Dyson'ed

			//} 

		}
		else
		{
			if(spikes[me].suckiness)
				player.yposoffset = 0;
			spikes[me].suckiness = 0;
		}
		
	}
	else
	{
		if(spikes[me].suckiness)
			player.yposoffset = 0;
		spikes[me].suckiness = 0;
	}

}

