// Sprite Joiner routines (debug only)
#if 1

// store all sprites' addresses in array so that they can be indexed by number

// store sprite x,y pos relative to centre (1st sprite)

/* controls

	L / R shoulder buttons = previous/next sprite
	with B
	L/R shoulder buttons = previous/next component
	D-pad	move component
	A Output data
*/

#include <AGB.h>
#include "main.h"
#include "asldefines.h"

const u32 SpriteAddress[64] = {
	PLAYER_SPRITE,
	ENEMY_SPRITE,
	MASK_MSPRITE,	
	FONT_SPRITE,	
	BUTTON_MSPRITE,
	PANEL_SPRITE1,
	BOSS_SPRITE1,
	BOSS_SPRITE1 + 64,
	BOSS_SPRITE1 + 128,
	BOSS_SPRITE1 + 192,
	BOSS_SPRITE1 + 256,
	BOSS_SPRITE1 + 320,
	BOSS_SPRITE1 + 384,
	BOSS_SPRITE1 + 448
};
const s8 jshape[32]  = {
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0
};
const s8 jsize[32] = {
	3,
	3,
	3,
	2,
	0,
	3,
	2,
	2,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	
};

s16 jspritex[32];
s16 jspritey[32];
u8  jspritenum[32];
u8 numjsprites;
u8 jsprite;
void SpriteJoinerInit(void)
{
	numjsprites = 1;
	jspritex[0] = 120;
	jspritey[0] = 80;
	jspritenum[0] = 0;
	jsprite = 0;
}

void SpriteJoiner(void)
{
	u8 a;
	
	for(a = 0; a < numjsprites;a++)
	{
		Sprite[a + 95].HPos = jspritex[a];
		Sprite[a + 95].VPos = jspritey[a]; 
		Sprite[a + 95].CharNo = SpriteAddress[jspritenum[a]];
      	Sprite[a + 95].Shape = jshape[jspritenum[a]]; //OAM_SQUARE;
   		Sprite[a + 95].Size = jsize[jspritenum[a]]; //OAM_SIZE_64x64;
	}
	if(controller & pad_B) // shift
	{
		if(controller_push & pad_L) // prev component
		{
			if(jsprite > 0)
				jsprite--;
		}
		if(controller_push & pad_R) // next component
		{
			if(jsprite < 32)
			{
				if(jsprite >= (numjsprites - 1))
				{
					jspritex[numjsprites] = jspritex[jsprite];
					jspritey[numjsprites] = jspritey[jsprite];
					jspritenum[numjsprites] = jspritenum[jsprite];
					numjsprites++;
				}
				jsprite++;
			}
			
		}
	}
	else
	{
		if(controller_push & pad_L) // prev sprite
		{
			if(jspritenum[jsprite] > 0)
				jspritenum[jsprite]--;
		}
		if(controller_push & pad_R) // next sprite
		{
			if(jspritenum[jsprite] < 14)
				jspritenum[jsprite]++;
		}
		if(controller & pad_up)
		{
			jspritey[jsprite]--;
		}
		if(controller & pad_down)
		{
			jspritey[jsprite]++;
		}
		if(controller & pad_left)
		{
			jspritex[jsprite]--;
		}
		if(controller & pad_right)
		{
			jspritex[jsprite]++;
		}
		if(controller_push & pad_A) // output data
		{
		//	AGBPrintf("Joined Sprite positions + frames\n");
			for(a = 0; a < numjsprites; a++)
			{
			//	AGBPrintf("%d) x,y = %d,%d. frame = %d\n",a,jspritex[a],jspritey[a],jspritenum[a]);
			}
		//	AGBPrintFlush();
		}
	}
	
}


#endif


