/*
 * vector.c: Vector handling functions
 */

#include "ModelLib.h"
#include <math.h>

void Vector_Cross(t_vec3 dest,t_vec3 src1,t_vec3 src2)
{
	dest[0] = asm_fx_AccurateMul(src1[1] , src2[2]) - asm_fx_AccurateMul(src1[2] , src2[1]);
	dest[1] = asm_fx_AccurateMul(src1[2] , src2[0]) - asm_fx_AccurateMul(src1[0] , src2[2]);
	dest[2] = asm_fx_AccurateMul(src1[0] , src2[1]) - asm_fx_AccurateMul(src1[1] , src2[0]);
}


void Vector_Normalise(t_vec3 dest)
{
	float length;

	length =	(ScalarToFloat(dest[0]) * ScalarToFloat(dest[0])) +
				(ScalarToFloat(dest[1]) * ScalarToFloat(dest[1])) +
				(ScalarToFloat(dest[2]) * ScalarToFloat(dest[2]));

	length = (float) sqrt(length);

	if (length > 0.0F)
	{
		dest[0] = FloatToScalar(ScalarToFloat(dest[0]) / length);
		dest[1] = FloatToScalar(ScalarToFloat(dest[1]) / length);
		dest[2] = FloatToScalar(ScalarToFloat(dest[2]) / length);
	}
}


#if 0
// Replaced by macro - MP
SCALAR Vector_Dot(t_vec3 src1,t_vec3 src2)
{
	SCALAR inter;

	/* Arghh no must use SMULL!!! */
#if 0
	inter = ScalarMulAcc(src1[0],src2[0]);
	inter += ScalarMulAcc(src1[1],src2[1]);
	inter += ScalarMulAcc(src1[2],src2[2]);
#else
	inter = BR_MAC3(src1[0],src2[0],src1[1],src2[1],src1[2],src2[2]);
#endif

	return inter;
}
#endif
