//======================================================
//	menuitem.c										   
//	Pointer to character array and function to display menu
//													  
//	Copyright (C) 1999-2001 NINTENDO Co.,Ltd.		 
//======================================================

#include <agb.h>
#include "share.h"
#include "menuitem.h"

//--------------------------- External reference  -----------------------
const char* ob_title_str = "OBJECT FUNCTIONS";

const char* ob_expl_str0 =
//   .	.	.	.	.	.Up to here (30 characters)
"Sample for scaling/rotation\n"
"of sprite and sample mosaic\n"
"Double field can be checked\n"
"\n"
"+ key	  Move\n"
"L button   Reduce mosaic\n"
"R button   Enlarge mosaic\n"
"B & +	  Scaling\n"
"B & LR	 Rotation\n"
"A button   Double field\n"
"		   ON/OFF"
//   .	.	.	.	.	.Up to here (30 characters)
;

const char** ob_expl_str_array[] =
{
	NULL,	//  Always start with NULL
	&ob_expl_str0,
	NULL,	//  Always end with NULL
};


//-------------------- Subroutines  ------------------------

static void ob_v_blank_intr(void);

//==============================================================
//					   Main routine
//==============================================================
void obMain(void)
{
	SetVBlankFunc( ob_v_blank_intr );

	// Set V Blank interrupt flag
	*(vu16 *)REG_IE |= V_BLANK_INTR_FLAG;
	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON | DISP_OBJ_CHAR_1D_MAP;


	while(1)
	{
	V_Wait();
	}
}
//==============================================================
//					Interrupt routine

//==============================================================

//--------------------------------------------------------------
//					V Blank function
//--------------------------------------------------------------
static void ob_v_blank_intr(void)
{
}


//-- Table to display menu and to call a callback function --

const MenuItem mitem[] =
{
	{NULL,NULL,NULL},

	{
	&ob_title_str,
	ob_expl_str_array,
	obMain,
	},

	{
	&ob_title_str,
	ob_expl_str_array,
	obMain,
	},

	{NULL,NULL,NULL},
};

